import BpmnModdle from "bpmn-moddle";
function parseXML(xml) {
  const moddle = new BpmnModdle();
  return moddle.fromXML(xml, "bpmn:Definitions", {});
}
function isFlowNode(businessObject) {
  var _a, _b;
  return (_b = (_a = businessObject.$instanceOf) == null ? void 0 : _a.call(businessObject, "bpmn:FlowNode")) != null ? _b : false;
}
function isSequenceFlow(businessObject) {
  var _a, _b;
  return (_b = (_a = businessObject.$instanceOf) == null ? void 0 : _a.call(businessObject, "bpmn:SequenceFlow")) != null ? _b : false;
}
function getFlowNodes(elementsById) {
  if (elementsById === void 0) {
    return [];
  }
  return Object.values(elementsById).filter(
    (businessObject) => isFlowNode(businessObject)
  );
}
export {
  getFlowNodes,
  isFlowNode,
  isSequenceFlow,
  parseXML
};
