var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { computed } from "vue";
import { dateRangeProps } from "./dateRange.mjs";
import { ElDatePicker } from "element-plus/es/index.mjs";
import { Range } from "../../range/index.mjs";
import dayjs from "dayjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("date-range");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: dateRangeProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const showClearable = computed(() => {
      return props.clearable && Boolean(startTime.value || endTime.value);
    });
    const valueFormatComputed = computed(() => {
      return props.valueFormat || {
        month: "YYYY-MM",
        year: "YYYY",
        date: "YYYY-MM-DD"
      }[props.type];
    });
    const startTime = computed(() => {
      return props.modelValue[0];
    });
    const endTime = computed(() => {
      return props.modelValue[1];
    });
    const startPickerAttrs = computed(() => {
      return getPickerProps("start", props.startPickerProps);
    });
    const endPickerAttrs = computed(() => {
      return getPickerProps("end", props.endPickerProps);
    });
    const startPlaceholder = computed(() => {
      return getPickerPlaceholder("start");
    });
    const endPlaceholder = computed(() => {
      return getPickerPlaceholder("end");
    });
    function getPickerProps(pickerType, pickerProps) {
      return Object.assign({}, pickerProps, {
        type: props.type,
        clearable: false,
        modelValue: pickerType === "start" ? startTime.value : endTime.value,
        placeholder: pickerType === "start" ? startPlaceholder.value : endPlaceholder.value,
        disabledDate: getDisabledDate(pickerType)
      });
    }
    function getPickerPlaceholder(pickerType) {
      const prefix = {
        start: "\u5F00\u59CB",
        end: "\u7ED3\u675F"
      }[pickerType];
      const text = {
        month: "\u6708\u4EFD",
        date: "\u5E74\u4EFD",
        year: "\u65E5\u671F"
      }[props.type];
      return `${prefix}${text}`;
    }
    function getDisabledDate(pickerType) {
      const isStartPicker = pickerType === "start";
      const pickerProps = isStartPicker ? props.startPickerProps : props.endPickerProps;
      return (pickerTime) => {
        const isDisabledDate = pickerProps && pickerProps.disabledDate ? pickerProps.disabledDate(pickerTime) : false;
        const time = isStartPicker ? endTime.value : startTime.value;
        if (!time)
          return isDisabledDate;
        const _pickerTime = dayjs(pickerTime).valueOf();
        const _time = dayjs(time).valueOf();
        return (isStartPicker ? _pickerTime > _time : _pickerTime < _time) || isDisabledDate;
      };
    }
    function handleClear() {
      emit("update:modelValue", []);
    }
    function handleUpdateStartValue(startTime2) {
      emit("update:modelValue", [startTime2, endTime.value]);
    }
    function handleUpdateEndValue(endTime2) {
      emit("update:modelValue", [startTime.value, endTime2]);
    }
    const __returned__ = { name, props, emit, showClearable, valueFormatComputed, startTime, endTime, startPickerAttrs, endPickerAttrs, startPlaceholder, endPlaceholder, getPickerProps, getPickerPlaceholder, getDisabledDate, handleClear, handleUpdateStartValue, handleUpdateEndValue, get ElDatePicker() {
      return ElDatePicker;
    }, get Range() {
      return Range;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { mergeProps as _mergeProps, createVNode as _createVNode, withCtx as _withCtx, openBlock as _openBlock, createBlock as _createBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["Range"], {
    class: "pagoda-date-range",
    "range-separator": _ctx.rangeSeparator,
    clearable: $setup.showClearable,
    onClear: $setup.handleClear
  }, {
    "range-start": _withCtx(({ focus, blur }) => [
      _createVNode($setup["ElDatePicker"], _mergeProps({ "value-format": $setup.valueFormatComputed }, $setup.startPickerAttrs, {
        "onUpdate:modelValue": $setup.handleUpdateStartValue,
        onFocus: focus,
        onBlur: blur
      }), null, 16, ["value-format", "onFocus", "onBlur"])
    ]),
    "range-end": _withCtx(({ focus, blur }) => [
      _createVNode($setup["ElDatePicker"], _mergeProps({ "value-format": $setup.valueFormatComputed }, $setup.endPickerAttrs, {
        "onUpdate:modelValue": $setup.handleUpdateEndValue,
        onFocus: focus,
        onBlur: blur
      }), null, 16, ["value-format", "onFocus", "onBlur"])
    ]),
    _: 1
    /* STABLE */
  }, 8, ["range-separator", "clearable"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
