var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, nextTick } from "vue";
import { dialogFormProps } from "./dialogForm.mjs";
import { ElDialog, ElForm, ElButton } from "element-plus/es/index.mjs";
import { useAttrsIgnore } from "pagoda-shared";
import { cloneDeep } from "lodash-unified";
import { PAGODA } from "../../utils/constants.mjs";
import { getAttrByKey } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("dialog-form");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: dialogFormProps,
  emits: ["update:modelValue", "save"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const attrs = useAttrsIgnore();
    const emit = __emit;
    let defaultFormData;
    const dialogAction = ref("create");
    const dialogVisible = ref(false);
    const formSubmiting = ref(false);
    const elFormCtx = ref();
    const elDialogProps = computed(() => {
      return Object.assign(
        {},
        {
          width: "500px"
        },
        props.dialogProps
      );
    });
    const title = computed(() => {
      return dialogAction.value === "create" ? props.createDialogTitle : props.editDialogTitle;
    });
    const isEditMode = computed(() => {
      return dialogAction.value === "edit";
    });
    function onElFormMounted() {
      defaultFormData = cloneDeep(props.modelValue);
    }
    function create() {
      return __async(this, null, function* () {
        yield show("create");
        emit("update:modelValue", cloneDeep(defaultFormData));
        yield nextTick();
        if (elFormCtx.value)
          elFormCtx.value.clearValidate();
      });
    }
    function edit(data) {
      return __async(this, null, function* () {
        yield show("edit");
        emit("update:modelValue", cloneDeep(data));
        yield nextTick();
        if (elFormCtx.value)
          elFormCtx.value.clearValidate();
      });
    }
    function show(action) {
      return __async(this, null, function* () {
        dialogAction.value = action;
        dialogVisible.value = true;
        yield nextTick();
      });
    }
    function handleCancel() {
      const beforeClose = getAttrByKey(
        props.dialogProps || {},
        "beforeClose"
      );
      if (beforeClose) {
        beforeClose(closeDialog);
      } else {
        closeDialog();
      }
    }
    function handleDialogClosed() {
      elFormCtx.value.clearValidate();
    }
    function closeLoading() {
      formSubmiting.value = false;
    }
    function closeDialog() {
      dialogVisible.value = false;
    }
    function handleSave() {
      return __async(this, null, function* () {
        if (attrs.value.rules) {
          yield elFormCtx.value.validate();
        }
        formSubmiting.value = true;
        emit("save", dialogAction.value, closeLoading, closeDialog);
      });
    }
    __expose({
      create,
      edit,
      elFormCtx
    });
    const __returned__ = { name, props, attrs, emit, get defaultFormData() {
      return defaultFormData;
    }, set defaultFormData(v) {
      defaultFormData = v;
    }, dialogAction, dialogVisible, formSubmiting, elFormCtx, elDialogProps, title, isEditMode, onElFormMounted, create, edit, show, handleCancel, handleDialogClosed, closeLoading, closeDialog, handleSave, get ElDialog() {
      return ElDialog;
    }, get ElForm() {
      return ElForm;
    }, get ElButton() {
      return ElButton;
    }, get PAGODA() {
      return PAGODA;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, withModifiers as _withModifiers, mergeProps as _mergeProps, withCtx as _withCtx, createVNode as _createVNode, toDisplayString as _toDisplayString, createTextVNode as _createTextVNode, createElementVNode as _createElementVNode, openBlock as _openBlock, createBlock as _createBlock } from "vue";
const _hoisted_1 = { class: "dialog-footer" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["ElDialog"], _mergeProps({
    ref: "elDialogCtx",
    modelValue: $setup.dialogVisible,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => $setup.dialogVisible = $event),
    "close-on-click-modal": false,
    "close-on-press-escape": false,
    "append-to-body": ""
  }, $setup.elDialogProps, {
    title: $setup.title,
    onClosed: $setup.handleDialogClosed
  }), {
    footer: _withCtx(() => [
      _createElementVNode("div", _hoisted_1, [
        _createVNode($setup["ElButton"], { onClick: $setup.handleCancel }, {
          default: _withCtx(() => [
            _createTextVNode(
              _toDisplayString(_ctx.cancelBtnText),
              1
              /* TEXT */
            )
          ]),
          _: 1
          /* STABLE */
        }),
        _createVNode($setup["ElButton"], {
          loading: $setup.formSubmiting,
          type: "primary",
          onClick: $setup.handleSave
        }, {
          default: _withCtx(() => [
            _createTextVNode(
              _toDisplayString(_ctx.submitBtnText),
              1
              /* TEXT */
            )
          ]),
          _: 1
          /* STABLE */
        }, 8, ["loading"])
      ])
    ]),
    default: _withCtx(() => [
      _createVNode($setup["ElForm"], _mergeProps({
        ref: "elFormCtx",
        onVnodeMounted: $setup.onElFormMounted,
        model: _ctx.modelValue,
        "label-width": `${$setup.PAGODA.form.labelWidth}px`
      }, _ctx.$attrs, {
        onSubmit: _cache[0] || (_cache[0] = _withModifiers(() => {
        }, ["prevent"]))
      }), {
        default: _withCtx(() => [
          _renderSlot(_ctx.$slots, "default", { isEditMode: $setup.isEditMode })
        ]),
        _: 3
        /* FORWARDED */
      }, 16, ["model", "label-width"]),
      _renderSlot(_ctx.$slots, "other")
    ]),
    _: 3
    /* FORWARDED */
  }, 16, ["modelValue", "title"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
