var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { provide, reactive, ref } from "vue";
import { dropdownProps } from "./dropdown.mjs";
import { onClickOutside } from "@vueuse/core";
import { DROPDOWN_INJECTION_KEY } from "./types/index.mjs";
import { addUnit } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("dropdown");
const __default__ = { name };
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: dropdownProps,
  setup(__props, { expose: __expose }) {
    const props = __props;
    const root = ref(null);
    const layout = reactive({
      left: 0,
      top: 0
    });
    const isShow = ref(false);
    const showOnMousePosition = (e) => {
      const relativeTarget = props.relativeTarget();
      if (!relativeTarget)
        return;
      const { left, top } = relativeTarget.getBoundingClientRect();
      const showLeft = e.x - left;
      const showTop = e.y - top;
      show({
        left: showLeft,
        top: showTop
      });
    };
    const show = ({ left, top }) => {
      layout.left = left;
      layout.top = top;
      isShow.value = true;
    };
    const hide = () => {
      isShow.value = false;
    };
    onClickOutside(root, hide);
    __expose({
      showOnMousePosition,
      show,
      hide
    });
    provide(DROPDOWN_INJECTION_KEY, {
      hideOnClick: props.hideOnClick,
      showOnMousePosition,
      show,
      hide
    });
    const __returned__ = { name, props, root, layout, isShow, showOnMousePosition, show, hide, get addUnit() {
      return addUnit;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, vShow as _vShow, normalizeClass as _normalizeClass, normalizeStyle as _normalizeStyle, withDirectives as _withDirectives, openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _withDirectives((_openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-dropdown", [_ctx.dropdownClass]]),
      style: _normalizeStyle({
        left: $setup.addUnit($setup.layout.left),
        top: $setup.addUnit($setup.layout.top)
      }),
      ref: "root"
    },
    [
      _renderSlot(_ctx.$slots, "default")
    ],
    6
    /* CLASS, STYLE */
  )), [
    [_vShow, $setup.isShow]
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
