var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent, withDirectives, computed, createVNode as _createVNode, mergeProps as _mergeProps } from "vue";
import { ElFormItem, ElCheckboxGroup, ElCheckbox, ElInput, ElSelect, ElOptionGroup, ElOption, ElRadio, ElRadioGroup, ElCascader, ElDatePicker, ElInputNumber, ElTimePicker, ElTimeSelect, ElSwitch, ElAutocomplete } from "element-plus/es/index.mjs";
import { merge } from "lodash-unified";
import { getProp } from "element-plus/es/utils/objects.mjs";
import { PagodaUiError, throwWarn } from "../../utils/error.mjs";
const componentsConfig = {
  "el-cascader": {
    component: ElCascader,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u9009\u62E9${label}`
      };
    },
    defaultValue(props) {
      var _a;
      return ((_a = props.props) == null ? void 0 : _a.multiple) ? [] : void 0;
    }
  },
  "el-date-picker": {
    component: ElDatePicker,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u9009\u62E9${label}`
      };
    }
  },
  "el-input-number": {
    component: ElInputNumber,
    defaultProps({
      label
    }) {
      return {
        placeholder: label && `\u8BF7\u586B\u5199${label}`
      };
    }
  },
  "el-time-picker": {
    component: ElTimePicker,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u9009\u62E9${label}`
      };
    }
  },
  "el-time-select": {
    component: ElTimeSelect,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u9009\u62E9${label}`
      };
    }
  },
  "el-switch": {
    component: ElSwitch
  },
  "el-autocomplete": {
    component: ElAutocomplete,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u586B\u5199${label}`
      };
    },
    defaultConfig() {
      return {
        trim: true
      };
    }
  },
  "el-input": {
    component: ElInput,
    defaultProps({
      label
    }) {
      return {
        clearable: true,
        placeholder: label && `\u8BF7\u586B\u5199${label}`
      };
    },
    defaultConfig() {
      return {
        trim: true
      };
    }
  },
  "el-select": {
    component: ElSelect,
    defaultProps({
      label
    }, {
      valueKey
    }) {
      return {
        clearable: true,
        valueKey,
        placeholder: label && `\u8BF7\u9009\u62E9${label}`
      };
    },
    defaultConfig() {
      return {
        options: []
      };
    },
    defaultValue(props) {
      return props.multiple ? [] : void 0;
    }
  },
  "el-checkbox-group": {
    component: ElCheckboxGroup,
    defaultConfig() {
      return {
        options: []
      };
    },
    defaultValue() {
      return [];
    }
  },
  "el-radio-group": {
    component: ElRadioGroup,
    defaultConfig() {
      return {
        options: []
      };
    }
  }
};
function resolveFieldConfig(field) {
  const {
    defaultConfig
  } = componentsConfig[field.type] || {};
  return merge({}, {
    labelKey: "label",
    valueKey: "value",
    disabledKey: "disabled"
  }, defaultConfig == null ? void 0 : defaultConfig(field), field.config);
}
function resolveFieldProps(field, config) {
  const {
    defaultProps
  } = componentsConfig[field.type] || {};
  return merge({}, defaultProps == null ? void 0 : defaultProps(field, config), field.props);
}
function resolveComponentSlots(slots, slotKey) {
  if (!slotKey)
    return;
  const r = {};
  Object.keys(slots).forEach((key) => {
    const [flag, name = "default"] = key.split("__");
    if (flag === `${slotKey}-content`) {
      r[name] = slots[key];
    }
  });
  return r;
}
function resolveBaseProps(option, config) {
  return {
    label: option[config.labelKey],
    value: config.bindObject ? option : option[config.valueKey],
    disabled: option[config.disabledKey]
  };
}
function getSpecialComponentRender(field, config, componentSlots) {
  const {
    options,
    valueKey,
    group
  } = config;
  switch (field.type) {
    case "el-checkbox-group":
      return () => options.map((option) => {
        const baseProps = resolveBaseProps(option, config);
        return _createVNode(ElCheckbox, {
          "key": option[valueKey],
          "value": baseProps.value,
          "disabled": baseProps.disabled
        }, {
          default: () => [baseProps.label]
        });
      });
    case "el-radio-group":
      return () => options.map((option) => {
        const baseProps = resolveBaseProps(option, config);
        return _createVNode(ElRadio, {
          "key": option[valueKey],
          "value": baseProps.value,
          "disabled": baseProps.disabled
        }, {
          default: () => [baseProps.label]
        });
      });
    case "el-select": {
      const renderOptions = (options2) => {
        return options2.map((option) => {
          const baseProps = resolveBaseProps(option, config);
          return _createVNode(ElOption, _mergeProps({
            "key": option[valueKey]
          }, baseProps), componentSlots);
        });
      };
      if (group) {
        return () => options.map(({
          label,
          options: options2
        }) => {
          return _createVNode(ElOptionGroup, {
            "key": label,
            "label": label
          }, {
            default: () => [renderOptions(options2)]
          });
        });
      } else {
        return () => renderOptions(options);
      }
    }
  }
}
var stdin_default = defineComponent({
  props: {
    field: {
      type: Object,
      required: true
    },
    slots: {
      type: Object,
      required: true
    },
    model: {
      type: Object
    }
  },
  setup(props) {
    const fieldConfig = computed(() => {
      return resolveFieldConfig(props.field);
    });
    const fieldProps = computed(() => {
      return resolveFieldProps(props.field, fieldConfig.value);
    });
    const fieldValue = computed({
      get: () => {
        var _a;
        const componentConfig = componentsConfig[props.field.type];
        if (!props.model || !props.field.prop) {
          return (_a = componentConfig == null ? void 0 : componentConfig.defaultValue) == null ? void 0 : _a.call(componentConfig, fieldProps.value);
        }
        return getProp(props.model, props.field.prop).value;
      },
      set(val) {
        if (props.model && props.field.prop) {
          getProp(props.model, props.field.prop).value = val;
        }
      }
    });
    function renderFieldContent(slotKey) {
      var _a, _b;
      if (props.field.type === "slot") {
        return (_b = (_a = props.slots)[`${slotKey}-form-content`]) == null ? void 0 : _b.call(_a);
      } else if (props.field.type === "text" || props.field.readonly) {
        const slot = props.slots[`${slotKey}-form-readonly`];
        const rawVal = fieldValue.value;
        const showText = () => props.field.textFormatter ? props.field.textFormatter(rawVal) : rawVal;
        return slot ? slot == null ? void 0 : slot() : showText();
      } else {
        const componentSlots = resolveComponentSlots(props.slots, slotKey);
        return renderFormComponent(props.field, componentSlots);
      }
    }
    function renderFormComponent(field, slots) {
      if (!field.type) {
        throw new PagodaUiError("Component: Form", `${JSON.stringify(field)} \u7F3A\u5C11 type \u5C5E\u6027`);
      } else if (!componentsConfig[field.type]) {
        throw new PagodaUiError("Component: Form", `${field.type} \u7EC4\u4EF6\u672A\u6CE8\u518C`);
      }
      const {
        component: FormComponent
      } = componentsConfig[field.type];
      const fieldEvents = field.events;
      const specialComponentRender = getSpecialComponentRender(field, fieldConfig.value, slots);
      const defaultSlot = specialComponentRender || (slots == null ? void 0 : slots.default);
      return withDirectives(_createVNode(FormComponent, _mergeProps(__spreadProps(__spreadValues(__spreadValues({}, fieldProps.value), fieldEvents), {
        modelValue: fieldValue.value,
        "onUpdate:modelValue"(val, ...arg) {
          var _a;
          if ((_a = fieldConfig.value) == null ? void 0 : _a.trim) {
            val = val.trim();
          }
          fieldValue.value = val;
          const ev = fieldEvents == null ? void 0 : fieldEvents["onUpdate:modelValue"];
          if (ev) {
            ev(val, ...arg);
          }
        }
      }), {
        "ref": field.ref
      }), __spreadProps(__spreadValues({}, slots), {
        default: defaultSlot
      })), field.directives || []);
    }
    return () => {
      const slotKey = props.field.slot || props.field.prop;
      return _createVNode(ElFormItem, {
        "prop": props.field.prop,
        "label": props.field.label,
        "rules": props.field.rules
      }, {
        default: () => {
          var _a, _b, _c, _d;
          return [(_b = (_a = props.slots)[`${slotKey}-before-component`]) == null ? void 0 : _b.call(_a), renderFieldContent(slotKey), (_d = (_c = props.slots)[`${slotKey}-after-component`]) == null ? void 0 : _d.call(_c)];
        },
        label: props.slots[`${slotKey}-form-label`],
        error: props.slots[`${slotKey}-form-error`]
      });
    };
  }
});
function registerComponents(config) {
  Object.keys(config).forEach((name) => {
    const componentConfig = config[name];
    if (name in componentsConfig) {
      throwWarn("Component: Form", `${name} \u7EC4\u4EF6\u91CD\u590D\u6CE8\u518C`);
    }
    componentsConfig[name] = componentConfig;
  });
}
export {
  componentsConfig,
  stdin_default as default,
  registerComponents
};
