import { defineComponent, ref, createVNode as _createVNode, mergeProps as _mergeProps } from "vue";
import { formProps } from "./form-props.mjs";
import { formProps as elFormProps } from "element-plus/es/index.mjs";
import { ElRow, ElCol, ElForm } from "element-plus/es/index.mjs";
import FieldItem from "./FieldItem.mjs";
import { usePickProps } from "pagoda-shared";
import { registerComponents } from "./FieldItem.mjs";
import { createNamespace } from "../../utils/index.mjs";
import { PagodaUiError } from "../../utils/error.mjs";
const name = createNamespace("form");
var stdin_default = defineComponent({
  name,
  registerComponents,
  props: formProps,
  setup(props, {
    slots,
    expose
  }) {
    const elFormCtx = ref();
    const elFormAttrs = usePickProps(props, elFormProps);
    function renderFields(grid, fields) {
      return fields.map((field) => {
        var _a;
        if (field.type !== "slot" && !field.prop) {
          console.error(new PagodaUiError("Component: Form", `field \u7F3A\u5C11 prop \u5C5E\u6027\uFF1A${JSON.stringify(field)}`));
        }
        if (field.hidden)
          return;
        const key = (_a = field.prop) != null ? _a : field.slot;
        return grid ? _createVNode(ElCol, _mergeProps(field.colProps, {
          "key": key
        }), {
          default: () => [_createVNode(FieldItem, {
            "field": field,
            "model": props.model,
            "slots": slots
          }, null)]
        }) : _createVNode(FieldItem, {
          "key": key,
          "field": field,
          "model": props.model,
          "slots": slots
        }, null);
      });
    }
    expose({
      elFormCtx
    });
    return () => _createVNode(ElForm, _mergeProps(elFormAttrs.value, {
      "ref": elFormCtx
    }), {
      default: () => {
        var _a;
        return [props.grid ? _createVNode(ElRow, props.gridRowProps, {
          default: () => [renderFields(props.grid, props.fields)]
        }) : renderFields(props.grid, props.fields), (_a = slots.default) == null ? void 0 : _a.call(slots)];
      }
    });
  }
});
export {
  stdin_default as default
};
