var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { isFunction, isPlainObject } from "lodash-unified";
function injectRouteComponentName(route) {
  const { name, component } = route;
  if (isFunction(component)) {
    route.component = function() {
      return __async(this, null, function* () {
        const componentOptions = (yield component()).default;
        componentOptions.name = route.name;
        return componentOptions;
      });
    };
  } else if (component && isPlainObject(component) && name) {
    component.name = name;
  }
}
export {
  injectRouteComponentName
};
