import { BaseSelect } from "./base-select/index.mjs";
import { BpmnViewer } from "./bpmn-viewer/index.mjs";
import { CollapseButton } from "./collapse-button/index.mjs";
import { Confirm } from "./confirm/index.mjs";
import { DateRange } from "./date-range/index.mjs";
import { DetailLayoutV1 } from "./detail-layout-v1/index.mjs";
import { DialogForm } from "./dialog-form/index.mjs";
import { Dropdown } from "./dropdown/index.mjs";
import { DropdownItem } from "./dropdown-item/index.mjs";
import { Flex } from "./flex/index.mjs";
import { FlexItem } from "./flex-item/index.mjs";
import { Form } from "./form/index.mjs";
import { FormEditItem } from "./form-edit-item/index.mjs";
import { FormTableLayout } from "./form-table-layout/index.mjs";
import { Icon } from "./icon/index.mjs";
import { InputNumber } from "./input-number/index.mjs";
import { Layout } from "./layout/index.mjs";
import { LayoutV2 } from "./layout-v2/index.mjs";
import { LayoutV2Header } from "./layout-v2-header/index.mjs";
import { LeftRightLayout } from "./left-right-layout/index.mjs";
import { Loading } from "./loading/index.mjs";
import { NumberRange } from "./number-range/index.mjs";
import { OverflowTooltip } from "./overflow-tooltip/index.mjs";
import { PopoverTextarea } from "./popover-textarea/index.mjs";
import { Range } from "./range/index.mjs";
import { RequestSelect } from "./request-select/index.mjs";
import { ResizeContainer } from "./resize-container/index.mjs";
import { SelectTree } from "./select-tree/index.mjs";
import { SubTitle } from "./sub-title/index.mjs";
import { SuffixIcon } from "./suffix-icon/index.mjs";
import { Table } from "./table/index.mjs";
import { TableColumn } from "./table-column/index.mjs";
import { TableEditable } from "./table-editable/index.mjs";
import { TableEditableCell } from "./table-editable-cell/index.mjs";
import { TableFooter } from "./table-footer/index.mjs";
import { VirtualList } from "./virtual-list/index.mjs";
import { VirtualTable } from "./virtual-table/index.mjs";
import packageSetup from "./setup.mjs";
const version = "3.9.1-beta.5";
function install(app, options) {
  var _a, _b;
  (_b = (_a = packageSetup).install) == null ? void 0 : _b.call(_a, app, options);
  const components = [
    BaseSelect,
    BpmnViewer,
    CollapseButton,
    Confirm,
    DateRange,
    DetailLayoutV1,
    DialogForm,
    Dropdown,
    DropdownItem,
    Flex,
    FlexItem,
    Form,
    FormEditItem,
    FormTableLayout,
    Icon,
    InputNumber,
    Layout,
    LayoutV2,
    LayoutV2Header,
    LeftRightLayout,
    Loading,
    NumberRange,
    OverflowTooltip,
    PopoverTextarea,
    Range,
    RequestSelect,
    ResizeContainer,
    SelectTree,
    SubTitle,
    SuffixIcon,
    Table,
    TableColumn,
    TableEditable,
    TableEditableCell,
    TableFooter,
    VirtualList,
    VirtualTable
  ];
  components.forEach((item) => {
    if (item.install) {
      app.use(item, options);
    } else if (item.name) {
      app.component(item.name, item);
    }
  });
}
export * from "./base-select/index.mjs";
export * from "./bpmn-viewer/index.mjs";
export * from "./collapse-button/index.mjs";
export * from "./confirm/index.mjs";
export * from "./date-range/index.mjs";
export * from "./detail-layout-v1/index.mjs";
export * from "./dialog-form/index.mjs";
export * from "./dropdown/index.mjs";
export * from "./dropdown-item/index.mjs";
export * from "./flex/index.mjs";
export * from "./flex-item/index.mjs";
export * from "./form/index.mjs";
export * from "./form-edit-item/index.mjs";
export * from "./form-table-layout/index.mjs";
export * from "./icon/index.mjs";
export * from "./input-number/index.mjs";
export * from "./layout/index.mjs";
export * from "./layout-v2/index.mjs";
export * from "./layout-v2-header/index.mjs";
export * from "./left-right-layout/index.mjs";
export * from "./loading/index.mjs";
export * from "./number-range/index.mjs";
export * from "./overflow-tooltip/index.mjs";
export * from "./popover-textarea/index.mjs";
export * from "./range/index.mjs";
export * from "./request-select/index.mjs";
export * from "./resize-container/index.mjs";
export * from "./select-tree/index.mjs";
export * from "./sub-title/index.mjs";
export * from "./suffix-icon/index.mjs";
export * from "./table/index.mjs";
export * from "./table-column/index.mjs";
export * from "./table-editable/index.mjs";
export * from "./table-editable-cell/index.mjs";
export * from "./table-footer/index.mjs";
export * from "./virtual-list/index.mjs";
export * from "./virtual-table/index.mjs";
export * from "./setup.mjs";
var stdin_default = install;
export {
  stdin_default as default,
  install,
  version
};
