var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { provide, ref, watch } from "vue";
import { layoutV2Props } from "./layoutV2.mjs";
import { ElTooltip } from "element-plus/es/index.mjs";
import { Icon } from "../../icon/index.mjs";
import { ClickOutside as vClickOutside } from "element-plus/es/directives/index.mjs";
import { LAYOUT_V2_INJECTION_KEY } from "./types/index.mjs";
import { useRoute, useRouter } from "vue-router";
import { getMatchUrlCollection } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("layout-v2");
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, {
  name
}), {
  __name: "layout-v2",
  props: layoutV2Props,
  emits: ["select-top-menu", "select-bottom-menu", "logo-click", "select-personal-setting-menu"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const router = useRouter();
    const route = useRoute();
    const hasHeader = ref(false);
    const personalSettingMenuVisible = ref(false);
    const userHeadTooltipVisible = ref(false);
    const subMenuActive = ref(false);
    const subMenu = ref();
    const activeSubMenu = ref(null);
    const activeTopMenu = ref(null);
    const activeBottomMenu = ref(null);
    if (router) {
      watch(router.currentRoute, setDefaultActive, {
        immediate: true
      });
      watch(() => [props.topMenu, props.bottomMenu], setDefaultActive);
    }
    function setDefaultActive() {
      const fullPath = route.fullPath.split("?")[0];
      const mathUrlCollection = getMatchUrlCollection(fullPath);
      activeBottomMenu.value = null;
      activeTopMenu.value = null;
      activeSubMenu.value = null;
      for (let i = 0; i < props.bottomMenu.length; i++) {
        const bottomMenuItem = props.bottomMenu[i];
        if (mathUrlCollection.includes(bottomMenuItem.url)) {
          activeBottomMenu.value = bottomMenuItem;
          return;
        }
      }
      for (let i = 0; i < props.topMenu.length; i++) {
        const topMenuItem = props.topMenu[i];
        if (!topMenuItem.subMenu && mathUrlCollection.includes(topMenuItem.url)) {
          activeTopMenu.value = topMenuItem;
          return;
        }
        if (topMenuItem.subMenu && topMenuItem.subMenu.data && topMenuItem.subMenu.data.length) {
          for (let i2 = 0; i2 < topMenuItem.subMenu.data.length; i2++) {
            const subMenuItem = topMenuItem.subMenu.data[i2];
            if (mathUrlCollection.includes(subMenuItem.url)) {
              activeTopMenu.value = topMenuItem;
              activeSubMenu.value = subMenuItem;
              return;
            }
          }
        }
      }
    }
    function handlePersonalMenuToogleVisible(e) {
      const target = e.target;
      userHeadTooltipVisible.value = false;
      if (target.tagName === "I" || target.tagName === "IMG" || target.className === "user" || target.className === "el-tooltip") {
        e.stopPropagation();
      }
      personalSettingMenuVisible.value = !personalSettingMenuVisible.value;
    }
    function hidePersonalSettingMenu() {
      personalSettingMenuVisible.value = false;
    }
    let hideMenuTimer;
    function handleHideMenu() {
      hideMenuTimer = window.setTimeout(() => {
        subMenuActive.value = false;
      }, 200);
    }
    function handleShowMenu() {
      clearTimeout(hideMenuTimer);
      subMenuActive.value = true;
    }
    function handleMenuMouseenter(e, menuItem) {
      if (menuItem.subMenu && menuItem.subMenu.data.length) {
        e.stopPropagation();
        handleShowMenu();
        subMenu.value = __spreadProps(__spreadValues({}, menuItem.subMenu), {
          title: menuItem.subMenu.title || menuItem.label,
          data: menuItem.subMenu.data.map((subMenu2) => {
            subMenu2._parent = menuItem;
            return subMenu2;
          })
        });
      }
    }
    provide(LAYOUT_V2_INJECTION_KEY, {
      hasHeader
    });
    const __returned__ = { name, props, emit, router, route, hasHeader, personalSettingMenuVisible, userHeadTooltipVisible, subMenuActive, subMenu, activeSubMenu, activeTopMenu, activeBottomMenu, setDefaultActive, handlePersonalMenuToogleVisible, hidePersonalSettingMenu, get hideMenuTimer() {
      return hideMenuTimer;
    }, set hideMenuTimer(v) {
      hideMenuTimer = v;
    }, handleHideMenu, handleShowMenu, handleMenuMouseenter, get ElTooltip() {
      return ElTooltip;
    }, get Icon() {
      return Icon;
    }, get vClickOutside() {
      return vClickOutside;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createCommentVNode as _createCommentVNode, createElementVNode as _createElementVNode, toDisplayString as _toDisplayString, renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, createBlock as _createBlock, normalizeClass as _normalizeClass, renderSlot as _renderSlot, withCtx as _withCtx, normalizeStyle as _normalizeStyle, withDirectives as _withDirectives, vShow as _vShow } from "vue";
const _hoisted_1 = { class: "pagoda-layout-v2" };
const _hoisted_2 = { class: "pagoda-layout-v2__submenu-subtitle" };
const _hoisted_3 = ["onClick"];
const _hoisted_4 = ["src"];
const _hoisted_5 = { class: "submenu-label" };
const _hoisted_6 = { class: "pagoda-layout-v2__left-menu" };
const _hoisted_7 = { class: "top-area" };
const _hoisted_8 = ["src"];
const _hoisted_9 = { class: "menu-list" };
const _hoisted_10 = ["onMouseenter", "onClick"];
const _hoisted_11 = { class: "menu-item__label" };
const _hoisted_12 = { class: "bottom-area" };
const _hoisted_13 = { class: "menu-list" };
const _hoisted_14 = ["onClick"];
const _hoisted_15 = ["src"];
const _hoisted_16 = ["src"];
const _hoisted_17 = ["onClick"];
const _hoisted_18 = { class: "personal-setting-menu__label" };
const _hoisted_19 = { class: "pagoda-layout-v2__content" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock("div", _hoisted_1, [
    $setup.subMenu ? (_openBlock(), _createElementBlock(
      "div",
      {
        key: 0,
        class: _normalizeClass(["pagoda-layout-v2__submenu", { active: $setup.subMenuActive }]),
        onMouseleave: $setup.handleHideMenu,
        onMouseenter: $setup.handleShowMenu
      },
      [
        _createCommentVNode('<div class="pagoda-layout-v2__submenu-title">{{subMenu.title}}</div>'),
        _createElementVNode("div", _hoisted_2, [
          _cache[5] || (_cache[5] = _createElementVNode(
            "i",
            { class: "dot" },
            null,
            -1
            /* HOISTED */
          )),
          _createElementVNode(
            "span",
            null,
            _toDisplayString($setup.subMenu.title),
            1
            /* TEXT */
          )
        ]),
        _createElementVNode("ul", {
          class: "pagoda-layout-v2__submenu-list",
          onClick: _cache[0] || (_cache[0] = ($event) => $setup.subMenuActive = false)
        }, [
          (_openBlock(true), _createElementBlock(
            _Fragment,
            null,
            _renderList($setup.subMenu.data, (subMenuItem) => {
              return _openBlock(), _createElementBlock("li", {
                key: subMenuItem.label,
                class: _normalizeClass({ active: $setup.activeSubMenu === subMenuItem }),
                onClick: ($event) => $setup.emit("select-top-menu", subMenuItem)
              }, [
                subMenuItem.icon ? (_openBlock(), _createBlock($setup["Icon"], {
                  key: 0,
                  class: "submenu-icon",
                  is: subMenuItem.icon
                }, null, 8, ["is"])) : subMenuItem.img ? (_openBlock(), _createElementBlock("img", {
                  key: 1,
                  src: subMenuItem.img,
                  class: "submenu-img"
                }, null, 8, _hoisted_4)) : _createCommentVNode("v-if", true),
                _createElementVNode(
                  "span",
                  _hoisted_5,
                  _toDisplayString(subMenuItem.label),
                  1
                  /* TEXT */
                )
              ], 10, _hoisted_3);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        _renderSlot(_ctx.$slots, `${$setup.subMenu.key}-after-menu`)
      ],
      34
      /* CLASS, NEED_HYDRATION */
    )) : _createCommentVNode("v-if", true),
    _createElementVNode("div", _hoisted_6, [
      _createElementVNode("div", _hoisted_7, [
        _createElementVNode("div", {
          class: "logo",
          onClick: _cache[1] || (_cache[1] = ($event) => $setup.emit("logo-click"))
        }, [
          _ctx.logoImg ? (_openBlock(), _createElementBlock("img", {
            key: 0,
            src: _ctx.logoImg
          }, null, 8, _hoisted_8)) : (_openBlock(), _createBlock($setup["Icon"], {
            key: 1,
            is: _ctx.logo
          }, null, 8, ["is"]))
        ]),
        _renderSlot(_ctx.$slots, "before-top-menu"),
        _createElementVNode("ul", _hoisted_9, [
          (_openBlock(true), _createElementBlock(
            _Fragment,
            null,
            _renderList(_ctx.topMenu, (menuItem) => {
              return _openBlock(), _createElementBlock("li", {
                key: menuItem.label,
                class: _normalizeClass(["menu-item", { active: $setup.activeTopMenu === menuItem }]),
                onMouseenter: ($event) => $setup.handleMenuMouseenter($event, menuItem),
                onMouseleave: $setup.handleHideMenu,
                onClick: ($event) => !menuItem.subMenu && $setup.emit("select-top-menu", menuItem)
              }, [
                menuItem.icon ? (_openBlock(), _createBlock($setup["Icon"], {
                  key: 0,
                  class: "menu-item__icon",
                  is: menuItem.icon
                }, null, 8, ["is"])) : _createCommentVNode("v-if", true),
                _createElementVNode(
                  "div",
                  _hoisted_11,
                  _toDisplayString(menuItem.label),
                  1
                  /* TEXT */
                )
              ], 42, _hoisted_10);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        _renderSlot(_ctx.$slots, "after-top-menu")
      ]),
      _createElementVNode("div", _hoisted_12, [
        _renderSlot(_ctx.$slots, "before-bottom-menu"),
        _createElementVNode("ul", _hoisted_13, [
          (_openBlock(true), _createElementBlock(
            _Fragment,
            null,
            _renderList(_ctx.bottomMenu, (menuItem) => {
              return _openBlock(), _createBlock($setup["ElTooltip"], {
                key: menuItem.icon,
                effect: "light",
                content: menuItem.label,
                placement: "right"
              }, {
                default: _withCtx(() => [
                  _createElementVNode("li", {
                    class: _normalizeClass(["menu-item", { active: $setup.activeBottomMenu === menuItem }]),
                    onClick: ($event) => $setup.emit("select-bottom-menu", menuItem)
                  }, [
                    menuItem.icon ? (_openBlock(), _createBlock($setup["Icon"], {
                      key: 0,
                      class: "menu-item__icon",
                      is: menuItem.icon
                    }, null, 8, ["is"])) : _createCommentVNode("v-if", true)
                  ], 10, _hoisted_14)
                ]),
                _: 2
                /* DYNAMIC */
              }, 1032, ["content"]);
            }),
            128
            /* KEYED_FRAGMENT */
          ))
        ]),
        _renderSlot(_ctx.$slots, "after-bottom-menu"),
        _createElementVNode("div", {
          class: "user",
          onClick: $setup.handlePersonalMenuToogleVisible
        }, [
          _ctx.userHead.tooltip ? (_openBlock(), _createBlock($setup["ElTooltip"], {
            key: 0,
            visible: $setup.userHeadTooltipVisible,
            "onUpdate:visible": _cache[4] || (_cache[4] = ($event) => $setup.userHeadTooltipVisible = $event),
            effect: "light",
            content: _ctx.userHead.tooltip,
            placement: "right",
            manual: ""
          }, {
            default: _withCtx(() => [
              _createElementVNode(
                "div",
                {
                  onMouseenter: _cache[2] || (_cache[2] = ($event) => !$setup.personalSettingMenuVisible && ($setup.userHeadTooltipVisible = true)),
                  onMouseleave: _cache[3] || (_cache[3] = ($event) => $setup.userHeadTooltipVisible = false)
                },
                [
                  _ctx.userHead.src ? (_openBlock(), _createElementBlock("img", {
                    key: 0,
                    class: "user-head",
                    src: _ctx.userHead.src
                  }, null, 8, _hoisted_15)) : (_openBlock(), _createBlock($setup["Icon"], {
                    key: 1,
                    class: "user-head",
                    is: "pd-icon-avatar"
                  }))
                ],
                32
                /* NEED_HYDRATION */
              )
            ]),
            _: 1
            /* STABLE */
          }, 8, ["visible", "content"])) : (_openBlock(), _createElementBlock(
            _Fragment,
            { key: 1 },
            [
              _ctx.userHead.src ? (_openBlock(), _createElementBlock("img", {
                key: 0,
                class: "user-head",
                src: _ctx.userHead.src
              }, null, 8, _hoisted_16)) : (_openBlock(), _createBlock($setup["Icon"], {
                key: 1,
                class: "user-head",
                is: "pd-icon-avatar"
              }))
            ],
            64
            /* STABLE_FRAGMENT */
          )),
          _ctx.personalSettingMenu.length ? _withDirectives((_openBlock(), _createElementBlock(
            "div",
            {
              key: 2,
              class: "personal-setting-menu",
              style: _normalizeStyle({ bottom: _ctx.personalSettingMenu.length === 1 ? "24px" : "0" })
            },
            [
              _createElementVNode(
                "div",
                {
                  class: "personal-setting-menu__triangle",
                  style: _normalizeStyle({
                    bottom: _ctx.personalSettingMenu.length === 1 ? "50%" : "36px",
                    transform: _ctx.personalSettingMenu.length === 1 ? "translateY(50%)" : "none"
                  })
                },
                null,
                4
                /* STYLE */
              ),
              (_openBlock(true), _createElementBlock(
                _Fragment,
                null,
                _renderList(_ctx.personalSettingMenu, (menuItem) => {
                  return _withDirectives((_openBlock(), _createElementBlock("div", {
                    key: menuItem.label,
                    class: "personal-setting-menu__item",
                    onClick: ($event) => $setup.emit("select-personal-setting-menu", menuItem)
                  }, [
                    menuItem.icon ? (_openBlock(), _createBlock($setup["Icon"], {
                      key: 0,
                      class: "personal-setting-menu__icon",
                      is: menuItem.icon
                    }, null, 8, ["is"])) : _createCommentVNode("v-if", true),
                    _createElementVNode(
                      "span",
                      _hoisted_18,
                      _toDisplayString(menuItem.label),
                      1
                      /* TEXT */
                    )
                  ], 8, _hoisted_17)), [
                    [$setup["vClickOutside"], $setup.hidePersonalSettingMenu]
                  ]);
                }),
                128
                /* KEYED_FRAGMENT */
              ))
            ],
            4
            /* STYLE */
          )), [
            [_vShow, $setup.personalSettingMenuVisible]
          ]) : _createCommentVNode("v-if", true)
        ])
      ])
    ]),
    _createElementVNode(
      "div",
      {
        class: _normalizeClass(["pagoda-layout-v2__main", { "has-header": $setup.hasHeader }])
      },
      [
        _createElementVNode("div", _hoisted_19, [
          _renderSlot(_ctx.$slots, "default")
        ])
      ],
      2
      /* CLASS */
    )
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
