import { InjectionKey, Ref } from 'vue';
export interface LayoutV2BaseMenuItem {
    icon?: string;
    label: string;
}
export interface LayoutV2TopMenuItem extends LayoutV2BaseMenuItem {
    url: string;
    subMenu?: {
        key?: string;
        title?: string;
        data: (LayoutV2BaseMenuItem & {
            url: string;
            img?: string;
            _parent: LayoutV2TopMenuItem;
        })[];
    };
}
export interface LayoutV2BottomMenuItem extends LayoutV2BaseMenuItem {
    url: string;
}
export type LayoutV2PersonalSettingMenuItem = LayoutV2BaseMenuItem;
export interface LayoutV2UserHeadConfig {
    src?: string;
    tooltip?: string;
}
export interface LayoutV2Provider {
    hasHeader: Ref<boolean>;
}
export declare const LAYOUT_V2_INJECTION_KEY: InjectionKey<LayoutV2Provider>;
