var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, useSlots, watch } from "vue";
import { layoutProps } from "./layout.mjs";
import {
  ElContainer,
  ElHeader,
  ElAside,
  ElMain,
  ElTabs,
  ElTabPane
} from "element-plus/es/index.mjs";
import PagodaDropdown from "../../dropdown/index.mjs";
import PagodaDropdownItem from "../../dropdown-item/index.mjs";
import LayoutUserInfo from "./user-info.vue.mjs";
import LayoutSideMenu from "./side-menu.vue.mjs";
import LayoutThemeToggler from "./theme-toggler.vue.mjs";
import { useTabs } from "./composables/useTabs.mjs";
import { useTabContextMenu } from "./composables/useTabContextMenu.mjs";
import { toggleDark } from "../../composables/dark.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("layout");
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, {
  name
}), {
  __name: "layout",
  props: layoutProps,
  emits: ["side-menu-select", "top-menu-select", "update:activeTab"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const slots = useSlots();
    const {
      currentTabName,
      tabs,
      isTabClosable,
      selectTab,
      closeActiveTab,
      closeTab,
      closeAllTabs,
      closeOthersTabs
    } = useTabs({
      activeTab: computed(() => props.activeTab),
      defaultTabs: props.defaultTabs,
      beforeTabsRemove: (removeTabsConfig, next) => {
        if (props.beforeTabsRemove) {
          props.beforeTabsRemove(removeTabsConfig, next);
          return;
        }
        next();
      },
      onActiveTabChange(activeTab) {
        emit("update:activeTab", activeTab);
      }
    });
    const { allTabContextMenus, contextmenuOnTab } = useTabContextMenu({
      isTabClosable,
      customTabContextMenus: computed(() => props.tabContextMenus),
      onCloseCurrentTab(mouseRightDownTab) {
        closeTab(mouseRightDownTab.name);
      },
      onCloseAllTabs() {
        closeAllTabs();
      },
      onCloseOthersTabs(mouseRightDownTab) {
        closeOthersTabs(mouseRightDownTab.name);
      }
    });
    const menuCollapse = ref(false);
    const isFullscreen = ref(false);
    let preTabName = "";
    const elTabsCtx = ref();
    const pagodaDropdownCtx = ref();
    const hasLogo = computed(() => {
      return Boolean(props.logo || slots.logo);
    });
    const hasLogoText = computed(() => {
      return Boolean(props.logoText || slots["logo-text"]);
    });
    const menuCollapseClass = computed(() => {
      return menuCollapse.value ? "pd-icon-open" : "pd-icon-retract";
    });
    const sideElMenuAttrs = computed(() => {
      return __spreadProps(__spreadValues({}, props.sideElMenuProps), { collapse: menuCollapse.value });
    });
    const topElMenuAttrs = computed(() => {
      return __spreadProps(__spreadValues({}, props.topElMenuProps), { mode: "horizontal", ellipsis: false });
    });
    const userInfoSlots = computed(() => {
      return Object.keys(slots).filter((name2) => name2.startsWith("user-info")).map((name2) => name2.replace("user-info-", ""));
    });
    watch(
      currentTabName,
      () => {
        preTabName = currentTabName.value;
      },
      {
        immediate: true
      }
    );
    function handleMenuCollapse(val) {
      menuCollapse.value = val;
    }
    function handleTopMenuSelect(item) {
      emit("top-menu-select", item);
    }
    function handleSideMenuSelect(item) {
      emit("side-menu-select", item);
    }
    function handleTabClick(tab) {
      elTabsCtx.value.currentName = preTabName;
      selectTab(tab);
    }
    function handleTabMounseRightDown(e) {
      var _a;
      const { target } = e;
      if (target.className.split(" ").includes("el-tabs__item")) {
        e.preventDefault();
        e.stopPropagation();
        (_a = pagodaDropdownCtx.value) == null ? void 0 : _a.showOnMousePosition(e);
        const mouseRightDownTabIdx = Array.from(
          elTabsCtx.value.$el.querySelectorAll(
            ".el-tabs__item"
          )
        ).findIndex((tabs2) => tabs2 === target);
        contextmenuOnTab(tabs.value[mouseRightDownTabIdx]);
      }
    }
    __expose({
      closeTab,
      closeActiveTab,
      closeAllTabs,
      closeOthersTabs
    });
    const __returned__ = { name, props, emit, slots, currentTabName, tabs, isTabClosable, selectTab, closeActiveTab, closeTab, closeAllTabs, closeOthersTabs, allTabContextMenus, contextmenuOnTab, menuCollapse, isFullscreen, get preTabName() {
      return preTabName;
    }, set preTabName(v) {
      preTabName = v;
    }, elTabsCtx, pagodaDropdownCtx, hasLogo, hasLogoText, menuCollapseClass, sideElMenuAttrs, topElMenuAttrs, userInfoSlots, handleMenuCollapse, handleTopMenuSelect, handleSideMenuSelect, handleTabClick, handleTabMounseRightDown, get ElContainer() {
      return ElContainer;
    }, get ElHeader() {
      return ElHeader;
    }, get ElAside() {
      return ElAside;
    }, get ElMain() {
      return ElMain;
    }, get ElTabs() {
      return ElTabs;
    }, get ElTabPane() {
      return ElTabPane;
    }, get PagodaDropdown() {
      return PagodaDropdown;
    }, get PagodaDropdownItem() {
      return PagodaDropdownItem;
    }, LayoutUserInfo, LayoutSideMenu, LayoutThemeToggler, get toggleDark() {
      return toggleDark;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createCommentVNode as _createCommentVNode, renderSlot as _renderSlot, createElementVNode as _createElementVNode, openBlock as _openBlock, createElementBlock as _createElementBlock, toDisplayString as _toDisplayString, normalizeClass as _normalizeClass, createVNode as _createVNode, normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, mergeProps as _mergeProps, withCtx as _withCtx, renderList as _renderList, createSlots as _createSlots, createBlock as _createBlock, vShow as _vShow, withDirectives as _withDirectives, Fragment as _Fragment, withModifiers as _withModifiers, createTextVNode as _createTextVNode } from "vue";
const _hoisted_1 = { class: "pagoda-layout__header-left" };
const _hoisted_2 = { class: "pagoda-layout__logo-container" };
const _hoisted_3 = {
  key: 0,
  class: "pagoda-layout__logo"
};
const _hoisted_4 = ["src"];
const _hoisted_5 = {
  key: 1,
  class: "pagoda-layout__logo-text"
};
const _hoisted_6 = { class: "pagoda-layout__header-right" };
const _hoisted_7 = {
  key: 0,
  class: "pagoda-layout__theme-toggler-content"
};
const _hoisted_8 = { class: "pagoda-layout__tabs-wrapper" };
const _hoisted_9 = { class: "pagoda-layout__main" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["ElContainer"], { class: "pagoda-layout" }, {
    default: _withCtx(() => [
      _withDirectives(_createVNode(
        $setup["ElHeader"],
        { class: "pagoda-layout__header" },
        {
          default: _withCtx(() => [
            _createCommentVNode(" header left "),
            _createElementVNode("div", _hoisted_1, [
              _createElementVNode("div", _hoisted_2, [
                _createCommentVNode(" logo "),
                $setup.hasLogo ? (_openBlock(), _createElementBlock("div", _hoisted_3, [
                  _renderSlot(_ctx.$slots, "logo", {}, () => [
                    _createElementVNode("img", { src: _ctx.logo }, null, 8, _hoisted_4)
                  ])
                ])) : _createCommentVNode("v-if", true),
                _createCommentVNode(" logo text "),
                $setup.hasLogoText ? (_openBlock(), _createElementBlock("div", _hoisted_5, [
                  _renderSlot(_ctx.$slots, "logo-text", {}, () => [
                    _createElementVNode(
                      "span",
                      null,
                      _toDisplayString(_ctx.logoText),
                      1
                      /* TEXT */
                    )
                  ])
                ])) : _createCommentVNode("v-if", true)
              ]),
              _createElementVNode("div", {
                class: "pagoda-layout__menu-controller",
                onClick: _cache[0] || (_cache[0] = ($event) => $setup.handleMenuCollapse(!$setup.menuCollapse))
              }, [
                _createElementVNode(
                  "i",
                  {
                    class: _normalizeClass(["pagoda-layout__menu-controller-icon", [$setup.menuCollapseClass]])
                  },
                  null,
                  2
                  /* CLASS */
                )
              ])
            ]),
            _createCommentVNode(" header right "),
            _createElementVNode("div", _hoisted_6, [
              _renderSlot(_ctx.$slots, "before-top-menu"),
              _createVNode($setup["LayoutSideMenu"], {
                class: "pagoda-layout__top-menu",
                ref: "layoutTopMenuCtx",
                "el-menu-props": $setup.topElMenuAttrs,
                "title-key": _ctx.titleKey,
                "children-key": _ctx.childrenKey,
                "icon-key": _ctx.iconKey,
                "index-key": _ctx.indexKey,
                menus: _ctx.topMenus,
                onSelect: $setup.handleTopMenuSelect
              }, null, 8, ["el-menu-props", "title-key", "children-key", "icon-key", "index-key", "menus"]),
              _renderSlot(_ctx.$slots, "after-top-menu"),
              _ctx.themeToggler ? (_openBlock(), _createElementBlock("div", _hoisted_7, [
                _createVNode($setup["LayoutThemeToggler"], {
                  onClick: _cache[1] || (_cache[1] = () => $setup.toggleDark())
                })
              ])) : _createCommentVNode("v-if", true),
              _renderSlot(_ctx.$slots, "before-user-info"),
              _ctx.userInfo ? (_openBlock(), _createBlock($setup["LayoutUserInfo"], _mergeProps({ key: 1 }, _ctx.userInfo, {
                "on-logout": _ctx.onLogout,
                "on-operate-item-click": _ctx.onOperateItemClick
              }), _createSlots({
                _: 2
                /* DYNAMIC */
              }, [
                _renderList($setup.userInfoSlots, (slotName) => {
                  return {
                    name: slotName,
                    fn: _withCtx((scope) => [
                      _renderSlot(_ctx.$slots, `user-info-${slotName}`, _normalizeProps(_guardReactiveProps(scope)))
                    ])
                  };
                })
              ]), 1040, ["on-logout", "on-operate-item-click"])) : _createCommentVNode("v-if", true),
              _renderSlot(_ctx.$slots, "after-user-info")
            ])
          ]),
          _: 3
          /* FORWARDED */
        },
        512
        /* NEED_PATCH */
      ), [
        [_vShow, !$setup.isFullscreen]
      ]),
      _createVNode($setup["ElContainer"], { style: { "min-height": "0" } }, {
        default: _withCtx(() => [
          _withDirectives(_createVNode(
            $setup["ElAside"],
            {
              ref: "elAsideCtx",
              class: "pagoda-layout__el-aside",
              width: "auto"
            },
            {
              default: _withCtx(() => [
                _createVNode($setup["LayoutSideMenu"], {
                  class: "pagoda-layout__side-menu",
                  ref: "layoutSideMenuCtx",
                  style: { "height": "100%" },
                  "title-key": _ctx.titleKey,
                  "children-key": _ctx.childrenKey,
                  "icon-key": _ctx.iconKey,
                  "index-key": _ctx.indexKey,
                  menus: _ctx.sideMenus,
                  "el-menu-props": $setup.sideElMenuAttrs,
                  onSelect: $setup.handleSideMenuSelect
                }, null, 8, ["title-key", "children-key", "icon-key", "index-key", "menus", "el-menu-props"])
              ]),
              _: 1
              /* STABLE */
            },
            512
            /* NEED_PATCH */
          ), [
            [_vShow, !$setup.isFullscreen]
          ]),
          _createVNode($setup["ElContainer"], null, {
            default: _withCtx(() => [
              _createVNode($setup["ElMain"], { class: "pagoda-layout__el-main" }, {
                default: _withCtx(() => [
                  _createElementVNode("div", _hoisted_8, [
                    $setup.tabs && $setup.tabs.length ? _withDirectives((_openBlock(), _createBlock($setup["ElTabs"], {
                      key: 0,
                      ref: "elTabsCtx",
                      "model-value": $setup.currentTabName,
                      class: "pagoda-layout__el-tabs",
                      type: "card",
                      onTabRemove: $setup.closeTab,
                      onTabClick: $setup.handleTabClick,
                      onContextmenu: _withModifiers($setup.handleTabMounseRightDown, ["right"])
                    }, {
                      default: _withCtx(() => [
                        (_openBlock(true), _createElementBlock(
                          _Fragment,
                          null,
                          _renderList($setup.tabs, (item) => {
                            return _openBlock(), _createBlock($setup["ElTabPane"], _mergeProps({
                              key: item.name,
                              ref_for: true
                            }, item, {
                              closable: $setup.isTabClosable(item)
                            }), null, 16, ["closable"]);
                          }),
                          128
                          /* KEYED_FRAGMENT */
                        ))
                      ]),
                      _: 1
                      /* STABLE */
                    }, 8, ["model-value", "onTabRemove"])), [
                      [_vShow, !$setup.isFullscreen]
                    ]) : _createCommentVNode("v-if", true),
                    _createVNode(
                      $setup["PagodaDropdown"],
                      { ref: "pagodaDropdownCtx" },
                      {
                        default: _withCtx(() => [
                          (_openBlock(true), _createElementBlock(
                            _Fragment,
                            null,
                            _renderList($setup.allTabContextMenus, (contextmenu) => {
                              return _openBlock(), _createBlock($setup["PagodaDropdownItem"], {
                                key: contextmenu.title,
                                disabled: contextmenu.disabled,
                                divided: contextmenu.divided,
                                onClick: ($event) => contextmenu.onClick && contextmenu.onClick($event, contextmenu)
                              }, {
                                default: _withCtx(() => [
                                  _createTextVNode(
                                    _toDisplayString(contextmenu.title),
                                    1
                                    /* TEXT */
                                  )
                                ]),
                                _: 2
                                /* DYNAMIC */
                              }, 1032, ["disabled", "divided", "onClick"]);
                            }),
                            128
                            /* KEYED_FRAGMENT */
                          ))
                        ]),
                        _: 1
                        /* STABLE */
                      },
                      512
                      /* NEED_PATCH */
                    ),
                    _ctx.fullscreen ? (_openBlock(), _createElementBlock("span", {
                      key: 1,
                      class: "pagoda-layout__fullscreen-control",
                      onClick: _cache[2] || (_cache[2] = ($event) => $setup.isFullscreen = !$setup.isFullscreen)
                    }, [
                      _createElementVNode(
                        "i",
                        {
                          class: _normalizeClass(["pagoda-layout__fullscreen-icon", [$setup.isFullscreen ? "pd-icon-reduction" : "pd-icon-fullscreen"]])
                        },
                        null,
                        2
                        /* CLASS */
                      ),
                      _createTextVNode(
                        " " + _toDisplayString($setup.isFullscreen ? "\u8FD8\u539F" : "\u5168\u5C4F"),
                        1
                        /* TEXT */
                      )
                    ])) : _createCommentVNode("v-if", true)
                  ]),
                  _createElementVNode("div", _hoisted_9, [
                    _renderSlot(_ctx.$slots, "default")
                  ])
                ]),
                _: 3
                /* FORWARDED */
              })
            ]),
            _: 3
            /* FORWARDED */
          })
        ]),
        _: 3
        /* FORWARDED */
      })
    ]),
    _: 3
    /* FORWARDED */
  });
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
