import { defineComponent as _defineComponent } from "vue";
import { inject } from "vue";
import { ElSubMenu, ElMenuItem, ElMenuItemGroup } from "element-plus/es/index.mjs";
import LayoutMenuItem from "./men-item.vue.mjs";
import { Icon } from "../../icon/index.mjs";
import { LAYOUT_SIDE_MENU_INJECTION_KEY } from "./types/side-menu.mjs";
const __vue_sfc__ = /* @__PURE__ */ _defineComponent({
  __name: "sub-menu",
  props: {
    menu: { type: Object, required: true },
    titleKey: { type: String, required: false, default: "title" },
    childrenKey: { type: String, required: false, default: "children" },
    iconKey: { type: String, required: false, default: "icon" },
    indexKey: { type: String, required: false, default: "index" }
  },
  setup(__props, { expose: __expose }) {
    __expose();
    const layoutSideMenuProvider = inject(LAYOUT_SIDE_MENU_INJECTION_KEY);
    const elMenuProvider = inject("rootMenu");
    function handleSelectItem(e, item) {
      if (Array.from(
        document.querySelectorAll(".el-menu--popup")
      ).some((menuPopup) => menuPopup.contains(e.target))) {
        elMenuProvider.openedMenus = [];
      }
      if (item.disabled)
        return;
      layoutSideMenuProvider.sideMenuEmitter.emit(
        "pagoda-layout:side-menu-item-click",
        item
      );
    }
    const __returned__ = { layoutSideMenuProvider, elMenuProvider, handleSelectItem, get ElSubMenu() {
      return ElSubMenu;
    }, get ElMenuItem() {
      return ElMenuItem;
    }, get ElMenuItemGroup() {
      return ElMenuItemGroup;
    }, LayoutMenuItem, get Icon() {
      return Icon;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
});
import { createVNode as _createVNode, renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, toDisplayString as _toDisplayString, createTextVNode as _createTextVNode, createCommentVNode as _createCommentVNode, withModifiers as _withModifiers, createElementVNode as _createElementVNode, createBlock as _createBlock, withCtx as _withCtx, resolveComponent as _resolveComponent } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_SubMenu = _resolveComponent("SubMenu", true);
  return $props.menu[$props.childrenKey] && $props.menu[$props.childrenKey].length ? (_openBlock(), _createBlock($setup["ElSubMenu"], {
    key: 0,
    index: $props.menu[$props.indexKey]
  }, {
    title: _withCtx(() => [
      _createVNode($setup["LayoutMenuItem"], {
        icon: $props.menu[$props.iconKey],
        title: $props.menu[$props.titleKey]
      }, null, 8, ["icon", "title"])
    ]),
    default: _withCtx(() => [
      (_openBlock(true), _createElementBlock(
        _Fragment,
        null,
        _renderList($props.menu[$props.childrenKey], (subMenu) => {
          return _openBlock(), _createElementBlock(
            _Fragment,
            {
              key: subMenu[$props.titleKey]
            },
            [
              subMenu.group ? (_openBlock(), _createBlock(
                $setup["ElMenuItemGroup"],
                { key: 0 },
                {
                  title: _withCtx(() => [
                    _createTextVNode(
                      _toDisplayString(subMenu[$props.titleKey]),
                      1
                      /* TEXT */
                    )
                  ]),
                  default: _withCtx(() => [
                    (_openBlock(true), _createElementBlock(
                      _Fragment,
                      null,
                      _renderList(subMenu[$props.childrenKey], (groupItem) => {
                        return _openBlock(), _createBlock($setup["ElMenuItem"], {
                          key: groupItem[$props.titleKey],
                          disabled: groupItem.disabled,
                          index: groupItem[$props.indexKey]
                        }, {
                          title: _withCtx(() => [
                            _createVNode($setup["LayoutMenuItem"], {
                              "show-icon": false,
                              icon: groupItem[$props.iconKey],
                              title: groupItem[$props.titleKey]
                            }, null, 8, ["icon", "title"])
                          ]),
                          default: _withCtx(() => [
                            _createElementVNode("div", {
                              class: "pagoda-layout-sidemenu-item-hack",
                              onClick: _cache[0] || (_cache[0] = _withModifiers(($event) => $setup.handleSelectItem($event, $props.menu), ["stop"]))
                            }),
                            $props.menu[$props.iconKey] ? (_openBlock(), _createBlock($setup["Icon"], {
                              key: 0,
                              is: $props.menu[$props.iconKey],
                              class: "pagoda-layout-sidemenu-icon"
                            }, null, 8, ["is"])) : _createCommentVNode("v-if", true)
                          ]),
                          _: 2
                          /* DYNAMIC */
                        }, 1032, ["disabled", "index"]);
                      }),
                      128
                      /* KEYED_FRAGMENT */
                    ))
                  ]),
                  _: 2
                  /* DYNAMIC */
                },
                1024
                /* DYNAMIC_SLOTS */
              )) : (_openBlock(), _createBlock(_component_SubMenu, {
                key: 1,
                menu: subMenu,
                "title-key": $props.titleKey,
                "icon-key": $props.iconKey,
                "children-key": $props.childrenKey,
                "index-key": $props.indexKey
              }, null, 8, ["menu", "title-key", "icon-key", "children-key", "index-key"]))
            ],
            64
            /* STABLE_FRAGMENT */
          );
        }),
        128
        /* KEYED_FRAGMENT */
      ))
    ]),
    _: 1
    /* STABLE */
  }, 8, ["index"])) : (_openBlock(), _createBlock($setup["ElMenuItem"], {
    key: 1,
    index: $props.menu[$props.indexKey],
    disabled: $props.menu.disabled
  }, {
    title: _withCtx(() => [
      _createVNode($setup["LayoutMenuItem"], {
        "show-icon": false,
        icon: $props.menu[$props.iconKey],
        title: $props.menu[$props.titleKey]
      }, null, 8, ["icon", "title"])
    ]),
    default: _withCtx(() => [
      _createElementVNode("div", {
        class: "pagoda-layout-sidemenu-item-hack",
        onClick: _cache[1] || (_cache[1] = _withModifiers(($event) => $setup.handleSelectItem($event, $props.menu), ["stop"]))
      }),
      $props.menu[$props.iconKey] ? (_openBlock(), _createBlock($setup["Icon"], {
        key: 0,
        is: $props.menu[$props.iconKey],
        class: "pagoda-layout-sidemenu-icon"
      }, null, 8, ["is"])) : _createCommentVNode("v-if", true)
    ]),
    _: 1
    /* STABLE */
  }, 8, ["index", "disabled"]));
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
