import type { InjectionKey } from 'vue';
import type { Emitter } from 'mitt';
export interface LayoutSideMenuKeyConfig {
    titleKey?: string;
    childrenKey?: string;
    iconKey?: string;
    indexKey?: string;
}
export interface LayoutMenuItem {
    icon?: string;
    title: string;
    index: string;
    group?: boolean;
    children?: LayoutMenuItem[];
    disabled?: boolean;
    [key: string]: any;
}
export interface LayoutSideMenuProvider {
    sideMenuEmitter: Emitter<LayoutSideMenuEmitterEvents>;
}
export type LayoutSideMenuEmitterEvents = {
    'pagoda-layout:side-menu-item-click': LayoutMenuItem;
};
export declare const LAYOUT_SIDE_MENU_INJECTION_KEY: InjectionKey<LayoutSideMenuProvider>;
