var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed } from "vue";
import { useTooltipProps } from "element-plus/es/index.mjs";
import { overflowTooltipProps } from "./overflowTooltip.mjs";
import { ElTooltip } from "element-plus/es/index.mjs";
import { usePickProps } from "pagoda-shared";
import { isTextOverflow } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("overflow-tooltip");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: overflowTooltipProps,
  setup(__props, { expose: __expose }) {
    __expose();
    const props = __props;
    const showTooltip = ref(false);
    const disabled = ref(true);
    const elTooltipAttrs = usePickProps(props, useTooltipProps, {
      ignoreClassAndStyle: true
    });
    const contentStyle = computed(() => {
      return {
        width: `${props.tooltipWidth}px`
      };
    });
    const tooltipDisabled = computed(() => {
      var _a;
      return (_a = props.disabled) != null ? _a : disabled.value;
    });
    const handleMouseEnter = (e) => {
      if (e.target && isTextOverflow(e.target)) {
        disabled.value = false;
      } else {
        disabled.value = true;
      }
    };
    const __returned__ = { name, props, showTooltip, disabled, elTooltipAttrs, contentStyle, tooltipDisabled, handleMouseEnter, get ElTooltip() {
      return ElTooltip;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { toDisplayString as _toDisplayString, renderSlot as _renderSlot, createTextVNode as _createTextVNode, normalizeClass as _normalizeClass, normalizeStyle as _normalizeStyle, createElementVNode as _createElementVNode, mergeProps as _mergeProps, withCtx as _withCtx, openBlock as _openBlock, createBlock as _createBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["ElTooltip"], _mergeProps({
    ref: "elPopoverCtx",
    disabled: $setup.tooltipDisabled
  }, $setup.elTooltipAttrs, {
    modelValue: $setup.showTooltip,
    "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => $setup.showTooltip = $event)
  }), {
    content: _withCtx(() => [
      _createElementVNode(
        "div",
        {
          style: _normalizeStyle($setup.contentStyle)
        },
        [
          _renderSlot(_ctx.$slots, "default")
        ],
        4
        /* STYLE */
      )
    ]),
    default: _withCtx(() => [
      _createElementVNode(
        "div",
        {
          class: _normalizeClass(["pagoda-overflow-tooltip", _ctx.$attrs.class]),
          style: _normalizeStyle(_ctx.style),
          onMouseenterCapture: $setup.handleMouseEnter
        },
        [
          _createTextVNode(
            _toDisplayString(_ctx.$attrs.style) + " ",
            1
            /* TEXT */
          ),
          _renderSlot(_ctx.$slots, "default")
        ],
        38
        /* CLASS, STYLE, NEED_HYDRATION */
      )
    ]),
    _: 3
    /* FORWARDED */
  }, 16, ["disabled", "modelValue"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
