var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { defineComponent as _defineComponent } from "vue";
import { computed, ref, watch, nextTick } from "vue";
import { popoverTextareaProps } from "./popoverTextarea.mjs";
import { ElInput, ElPopover, ElButton } from "element-plus/es/index.mjs";
import { Icon } from "../../icon/index.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("popover-textarea");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: popoverTextareaProps,
  emits: ["update:modelValue", "confirm", "cancel"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const showPopover = ref(false);
    const textareaValue = ref(props.modelValue);
    const preValue = ref(props.modelValue);
    const elInputCtx = ref();
    watch(
      () => props.modelValue,
      (newVal) => {
        preValue.value = newVal;
        textareaValue.value = newVal;
      }
    );
    const popoverAttrs = computed(() => {
      const { popoverProps } = props;
      return Object.assign(
        {
          placement: "right",
          width: 250,
          title: "\u4FEE\u6539\u5907\u6CE8"
        },
        popoverProps,
        {
          trigger: "manual",
          popperClass: "pagoda-popover-textarea-poppver" + (popoverProps.popperClass ? ` ${popoverProps.popperClass}` : "")
        }
      );
    });
    const handleReferenceClick = () => __async(this, null, function* () {
      showPopover.value = true;
      preValue.value = props.modelValue;
      yield nextTick();
      elInputCtx.value.focus();
    });
    const handleConfirm = () => {
      showPopover.value = false;
      emit("update:modelValue", textareaValue.value);
      emit("confirm");
    };
    const handleCancel = () => {
      showPopover.value = false;
      if (textareaValue.value !== preValue.value) {
        textareaValue.value = preValue.value;
      }
      emit("cancel");
    };
    const __returned__ = { name, props, emit, showPopover, textareaValue, preValue, elInputCtx, popoverAttrs, handleReferenceClick, handleConfirm, handleCancel, get ElInput() {
      return ElInput;
    }, get ElPopover() {
      return ElPopover;
    }, get ElButton() {
      return ElButton;
    }, get Icon() {
      return Icon;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createVNode as _createVNode, toDisplayString as _toDisplayString, createTextVNode as _createTextVNode, withCtx as _withCtx, createElementVNode as _createElementVNode, mergeProps as _mergeProps, openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
const _hoisted_1 = { class: "pagoda-popover-textarea" };
const _hoisted_2 = { class: "pagoda-popover-textarea-poppver__operate" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock("div", _hoisted_1, [
    _createVNode($setup["ElPopover"], _mergeProps($setup.popoverAttrs, {
      visible: $setup.showPopover,
      "onUpdate:visible": _cache[1] || (_cache[1] = ($event) => $setup.showPopover = $event)
    }), {
      reference: _withCtx(() => [
        _createVNode($setup["ElButton"], {
          type: "primary",
          link: "",
          onClick: $setup.handleReferenceClick
        }, {
          default: _withCtx(() => [
            _createVNode($setup["Icon"], { is: _ctx.buttonIcon }, null, 8, ["is"]),
            _createTextVNode(
              " " + _toDisplayString(_ctx.buttonText),
              1
              /* TEXT */
            )
          ]),
          _: 1
          /* STABLE */
        })
      ]),
      default: _withCtx(() => [
        _createVNode($setup["ElInput"], {
          modelValue: $setup.textareaValue,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => $setup.textareaValue = $event),
          type: "textarea",
          resize: "none",
          rows: 4,
          "show-word-limit": "",
          maxlength: _ctx.maxlength,
          spellcheck: "false",
          ref: "elInputCtx"
        }, null, 8, ["modelValue", "maxlength"]),
        _createElementVNode("div", _hoisted_2, [
          _createVNode($setup["ElButton"], {
            type: "primary",
            link: "",
            onClick: $setup.handleCancel
          }, {
            default: _withCtx(() => _cache[2] || (_cache[2] = [
              _createTextVNode(" \u53D6\u6D88 ")
            ])),
            _: 1
            /* STABLE */
          }),
          _createVNode($setup["ElButton"], {
            type: "primary",
            onClick: $setup.handleConfirm
          }, {
            default: _withCtx(() => _cache[3] || (_cache[3] = [
              _createTextVNode(" \u786E\u8BA4 ")
            ])),
            _: 1
            /* STABLE */
          })
        ])
      ]),
      _: 1
      /* STABLE */
    }, 16, ["visible"])
  ]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
