var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { computed, ref } from "vue";
import { rangeProps } from "./range.mjs";
import { SuffixIcon } from "../../suffix-icon/index.mjs";
import { CircleClose } from "@element-plus/icons-vue";
import { useGlobalConfig } from "element-plus/es/index.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("range");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: rangeProps,
  emits: ["clear"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const size = useGlobalConfig("size");
    const rangeStartFocus = ref(false);
    const rangeEndFocus = ref(false);
    const focus = computed(() => {
      return rangeStartFocus.value || rangeEndFocus.value;
    });
    const sizeComputed = computed(() => {
      return props.size || size.value || "default";
    });
    function handleRangeFocusChange(type, focus2) {
      if (type === "start") {
        rangeStartFocus.value = focus2;
      } else {
        rangeEndFocus.value = focus2;
      }
    }
    function handleClear() {
      emit("clear");
    }
    const __returned__ = { name, props, emit, size, rangeStartFocus, rangeEndFocus, focus, sizeComputed, handleRangeFocusChange, handleClear, get SuffixIcon() {
      return SuffixIcon;
    }, get CircleClose() {
      return CircleClose;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, createElementVNode as _createElementVNode, toDisplayString as _toDisplayString, normalizeClass as _normalizeClass, withCtx as _withCtx, openBlock as _openBlock, createBlock as _createBlock } from "vue";
const _hoisted_1 = { class: "pagoda-range__range-start" };
const _hoisted_2 = { class: "date-range-separator" };
const _hoisted_3 = { class: "pagoda-range__range-end" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["SuffixIcon"], {
    icon: _ctx.clearable ? $setup.CircleClose : "",
    "icon-class": "pagoda-rang-clear-icon",
    class: _normalizeClass(["pagoda-range", [
      {
        "pagoda-range--focus": $setup.focus
      },
      `pagoda-range--${$setup.sizeComputed}`
    ]]),
    onIconClick: $setup.handleClear
  }, {
    default: _withCtx(() => [
      _createElementVNode("div", _hoisted_1, [
        _renderSlot(_ctx.$slots, "range-start", {
          focus: () => $setup.handleRangeFocusChange("start", true),
          blur: () => $setup.handleRangeFocusChange("start", false)
        })
      ]),
      _createElementVNode(
        "span",
        _hoisted_2,
        _toDisplayString(_ctx.rangeSeparator),
        1
        /* TEXT */
      ),
      _createElementVNode("div", _hoisted_3, [
        _renderSlot(_ctx.$slots, "range-end", {
          focus: () => $setup.handleRangeFocusChange("end", true),
          blur: () => $setup.handleRangeFocusChange("end", false)
        })
      ])
    ]),
    _: 3
    /* FORWARDED */
  }, 8, ["icon", "class"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
