var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { defineComponent as _defineComponent } from "vue";
import { ref, watch, computed } from "vue";
import { useLocale } from "element-plus/es/index.mjs";
import { requestSelectProps } from "./requestSelect.mjs";
import { baseSelectProps } from "../../base-select/index.mjs";
import { usePickProps } from "pagoda-shared";
import { BaseSelect } from "../../base-select/index.mjs";
import { isEqual, unionBy, debounce } from "lodash-unified";
import { isEmpty } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("request-select");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: requestSelectProps,
  emits: ["visible-change", "update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const { t } = useLocale();
    const baseSelectCtx = ref();
    const elSelectCtx = ref();
    const options = ref([]);
    const remoteQuery = ref("");
    const loading = ref(false);
    const requestError = ref(false);
    let lastRequest;
    const baseSelectAttrs = usePickProps(props, baseSelectProps);
    const filterMethod = computed(() => {
      return props.filterRemote ? handleRemote : void 0;
    });
    const filterableComputed = computed(() => {
      return props.remote || props.filterRemote || props.filterable;
    });
    const emptyText = computed(() => {
      return requestError.value ? props.errorText : props.noDataText || t("el.select.noData");
    });
    watch(remoteQuery, () => {
      refresh();
    });
    watch(
      () => props.params,
      (newVal, oldVal) => {
        if (!isEqual(newVal, oldVal)) {
          if (props.clearOnParamsChange) {
            clear();
          }
          refresh();
        }
      },
      {
        deep: true
      }
    );
    const addNewOption = () => {
      var _a;
      if (props.bindObject && !isEmpty(props.modelValue) && ((_a = remoteQuery.value) == null ? void 0 : _a.length) === 0) {
        const val = props.multiple ? props.modelValue : [props.modelValue];
        options.value = unionBy([...options.value, ...val], (option) => {
          return option[props.valueKey];
        });
      }
    };
    const clear = () => {
      handleUpdateModelValue(props.multiple ? [] : "");
    };
    const refresh = () => __async(this, null, function* () {
      loading.value = true;
      const currentRequest = lastRequest = props.request(
        props.params,
        remoteQuery.value || ""
      );
      const ifLastRequest = (next) => {
        if (currentRequest === lastRequest) {
          next();
        }
      };
      try {
        const opts = yield currentRequest;
        ifLastRequest(() => {
          options.value = opts;
          loading.value = false;
          requestError.value = false;
          addNewOption();
        });
      } catch (e) {
        console.error(e);
        ifLastRequest(() => {
          options.value = [];
          loading.value = false;
          requestError.value = true;
          lastRequest = void 0;
        });
      }
    });
    const handleRemote = debounce((query) => {
      remoteQuery.value = query == null ? void 0 : query.trim();
    }, 180);
    const handleVisibleChange = (visible) => {
      var _a;
      if (visible) {
        if (props.clearQueryOnFocus && ((_a = remoteQuery.value) == null ? void 0 : _a.length) !== 0) {
          remoteQuery.value = "";
        }
        if (props.refreshAfterEachFocus || (props.requestAfterFocus || requestError.value) && !lastRequest) {
          refresh();
        }
      }
      emit("visible-change", visible);
    };
    const handleUpdateModelValue = (val) => {
      emit("update:modelValue", val);
    };
    const setRef = (el) => {
      var _a;
      baseSelectCtx.value = el;
      elSelectCtx.value = (_a = baseSelectCtx.value) == null ? void 0 : _a.elSelectCtx;
    };
    watch(
      [() => props.autoRequest, () => props.requestAfterFocus],
      () => {
        if (props.autoRequest && !props.requestAfterFocus && !lastRequest) {
          refresh();
        }
      },
      {
        immediate: true
      }
    );
    watch(() => props.modelValue, addNewOption, {
      immediate: true
    });
    __expose({
      refresh,
      elSelectCtx
    });
    const __returned__ = { name, props, emit, t, baseSelectCtx, elSelectCtx, options, remoteQuery, loading, requestError, get lastRequest() {
      return lastRequest;
    }, set lastRequest(v) {
      lastRequest = v;
    }, baseSelectAttrs, filterMethod, filterableComputed, emptyText, addNewOption, clear, refresh, handleRemote, handleVisibleChange, handleUpdateModelValue, setRef, get BaseSelect() {
      return BaseSelect;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, renderSlot as _renderSlot, mergeProps as _mergeProps, withCtx as _withCtx, renderList as _renderList, createSlots as _createSlots, openBlock as _openBlock, createBlock as _createBlock } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["BaseSelect"], _mergeProps({
    class: "pagoda-request-select",
    "filter-method": $setup.filterMethod
  }, $setup.baseSelectAttrs, {
    filterable: $setup.filterableComputed,
    options: $setup.options,
    loading: $setup.loading,
    "remote-method": $setup.handleRemote,
    "no-data-text": $setup.emptyText,
    onVisibleChange: $setup.handleVisibleChange,
    "onUpdate:modelValue": $setup.handleUpdateModelValue,
    ref: $setup.setRef
  }), _createSlots({
    _: 2
    /* DYNAMIC */
  }, [
    _renderList(_ctx.$slots, (_, slotName) => {
      return {
        name: slotName,
        fn: _withCtx((scope) => [
          _renderSlot(_ctx.$slots, slotName, _normalizeProps(_guardReactiveProps(scope)))
        ])
      };
    })
  ]), 1040, ["filter-method", "filterable", "options", "loading", "remote-method", "no-data-text"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
