var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, reactive, onMounted } from "vue";
import { useResizeObserver } from "@vueuse/core";
import { resizeContainerProps } from "./resizeContainer.mjs";
import { addUnit } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("resize-container");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: resizeContainerProps,
  emits: ["drag-start", "draging", "drag-end"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const dragState = ref("drag-end");
    const size = ref(NaN);
    const rootViewRectSize = reactive({
      width: 0,
      heigth: 0
    });
    const resizeAreaEl = ref();
    const rootEl = ref();
    useResizeObserver(rootEl, () => {
      if (rootEl.value) {
        Object.assign(rootViewRectSize, getViewSize(rootEl.value));
        setSize(size.value);
      }
    });
    const defaultSizeComputed = computed(() => {
      var _a;
      return (_a = props.defaultSize) != null ? _a : props.minSize;
    });
    const propMap = computed(() => {
      return {
        row: {
          offset: "offsetWidth",
          client: "clientX",
          cursor: "col-resize",
          size: "width"
        },
        column: {
          offset: "offsetHeight",
          client: "clientY",
          cursor: "row-resize",
          size: "height"
        }
      }[props.direction];
    });
    const rootViewSize = computed(() => {
      return rootViewRectSize[propMap.value.size];
    });
    const maxSizeNumber = computed(() => {
      return typeof props.maxSize === "number" ? props.maxSize : getSizeFromPercent(props.maxSize);
    });
    const minSizeNumber = computed(() => {
      return typeof props.minSize === "number" ? props.minSize : getSizeFromPercent(props.minSize);
    });
    onMounted(() => {
      Object.assign(rootViewRectSize, getViewSize(rootEl.value));
      setSize(defaultSizeComputed.value);
    });
    function getSizeFromPercent(percent) {
      return rootViewSize.value * parseFloat(percent) / 100;
    }
    function getViewSize(el) {
      const style = getComputedStyle(el);
      const toNum = (v) => Math.round(Number(parseFloat(v)));
      return {
        width: toNum(style.width) - toNum(style.paddingLeft) - toNum(style.paddingRight) - toNum(style.borderLeftWidth) - toNum(style.borderRightWidth),
        height: toNum(style.height) - toNum(style.paddingTop) - toNum(style.paddingBottom) - toNum(style.borderTopWidth) - toNum(style.borderBottomWidth)
      };
    }
    function handleDragBarMouseDown(e) {
      const startPoint = e[propMap.value.client];
      const resizeAreaSize = resizeAreaEl.value[propMap.value.offset];
      let changeSize;
      const originalCursor = getComputedStyle(document.documentElement).cursor;
      dragState.value = "drag-start";
      document.documentElement.style.cursor = propMap.value.cursor;
      emit("drag-start", size.value);
      document.onmousemove = (e2) => {
        e2.preventDefault();
        dragState.value = "draging";
        const curPoint = e2[propMap.value.client];
        let distPoint = Math.abs(curPoint - startPoint);
        if (props.reverse)
          distPoint = -distPoint;
        changeSize = Math.floor(
          curPoint > startPoint ? resizeAreaSize + distPoint : resizeAreaSize - distPoint
        );
        setSize(changeSize);
        emit("draging", size.value);
      };
      document.onmouseup = () => {
        dragState.value = "drag-end";
        document.documentElement.style.cursor = originalCursor === "auto" ? "" : originalCursor;
        document.onmousemove = null;
        document.onmouseup = null;
        emit("drag-end", size.value);
      };
    }
    function setSize(v) {
      if (typeof v === "string") {
        v = getSizeFromPercent(v);
      }
      size.value = v > minSizeNumber.value ? v < maxSizeNumber.value ? v : maxSizeNumber.value : minSizeNumber.value;
    }
    function setSizeToMin() {
      setSize(minSizeNumber.value);
    }
    function setSizeToMax() {
      setSize(maxSizeNumber.value);
    }
    __expose({
      setSize,
      setSizeToMin,
      setSizeToMax
    });
    const __returned__ = { name, props, emit, dragState, size, rootViewRectSize, resizeAreaEl, rootEl, defaultSizeComputed, propMap, rootViewSize, maxSizeNumber, minSizeNumber, getSizeFromPercent, getViewSize, handleDragBarMouseDown, setSize, setSizeToMin, setSizeToMax, get addUnit() {
      return addUnit;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createElementVNode as _createElementVNode, renderSlot as _renderSlot, normalizeStyle as _normalizeStyle, normalizeClass as _normalizeClass, openBlock as _openBlock, createElementBlock as _createElementBlock } from "vue";
const _hoisted_1 = { class: "pagoda-resize-container__flex-area" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-resize-container", [
        `pagoda-resize-container--${$setup.dragState}`,
        `pagoda-resize-container--direction-${_ctx.direction}`,
        { "pagoda-resize-container--reverse": _ctx.reverse }
      ]]),
      ref: "rootEl"
    },
    [
      _createElementVNode(
        "div",
        {
          ref: "resizeAreaEl",
          class: "pagoda-resize-container__resize-area",
          style: _normalizeStyle({
            [$setup.propMap.size]: !Number.isNaN($setup.size) ? $setup.addUnit($setup.size) : $setup.addUnit($setup.defaultSizeComputed)
          })
        },
        [
          _createElementVNode(
            "span",
            {
              class: "pagoda-resize-container__drag-bar",
              onMousedown: $setup.handleDragBarMouseDown
            },
            null,
            32
            /* NEED_HYDRATION */
          ),
          _renderSlot(_ctx.$slots, "resize-area")
        ],
        4
        /* STYLE */
      ),
      _createElementVNode("div", _hoisted_1, [
        _renderSlot(_ctx.$slots, "flex-area")
      ])
    ],
    2
    /* CLASS */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
