var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, watch, nextTick } from "vue";
import { selectTreeProps } from "./selectTree.mjs";
import { ElTree, ElSelect, ElOption } from "element-plus/es/index.mjs";
import { isObject, isString } from "lodash-unified";
import { isEmpty } from "pagoda-shared";
import { getCheckedNodes } from "../../utils/component/tree.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("select-tree");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: selectTreeProps,
  emits: ["update:modelValue"],
  setup(__props, { expose: __expose, emit: __emit }) {
    __expose();
    const props = __props;
    const emit = __emit;
    const elOptions = ref([]);
    const elSelectCtx = ref();
    const elTreeCtx = ref();
    const selectAttrs = computed(() => {
      return Object.assign({}, props.selectProps, {
        valueKey: props.valueKey,
        clearable: props.clearable,
        collapseTags: props.collapseTags
      });
    });
    const treeAttrs = computed(() => {
      return Object.assign({}, props.treeProps, {
        props: {
          label: props.label,
          children: props.childrenKey,
          disabled: props.disabled,
          isLeaf: props.isLeaf
        },
        lazy: props.lazy,
        load: props.load,
        checkStrictly: props.checkStrictly,
        nodeKey: props.valueKey
      });
    });
    const defaultExpanded = computed(() => {
      return props.lazy ? [] : props.multiple ? props.modelValue.map((v) => getValue(v)) : [props.modelValue];
    });
    watch(
      [() => props.modelValue, () => props.data],
      () => __async(this, null, function* () {
        yield nextTick();
        if (isEmpty(props.modelValue) || !props.lazy && isEmpty(props.data)) {
          elOptions.value = [];
        } else {
          elOptions.value = props.multiple ? props.modelValue.map(
            (value) => getElOption(value)
          ) : [getElOption(props.modelValue)];
        }
        if (props.multiple) {
          elTreeCtx.value.setCheckedKeys(
            elOptions.value.map(({ value }) => getValue(value)),
            false
          );
        }
      }),
      { immediate: true }
    );
    function getValue(value) {
      return isObject(value) ? value[props.valueKey] : value;
    }
    function getNode(value) {
      const { nodesMap } = elTreeCtx.value.store;
      return nodesMap[getValue(value)];
    }
    function getElOption(value) {
      return props.lazy ? {
        label: isString(props.label) ? value[props.label] : props.label(value),
        value
      } : getElOptionFromNode(getNode(value));
    }
    function getElOptionFromNode(node) {
      return {
        label: node.label,
        value: getValueFromData(node.data)
      };
    }
    function getTreeNodeClass({ data: nodeData, disabled, isLeaf }) {
      return {
        "pagoda-select-tree-node--selected": props.multiple ? props.modelValue.some(
          (value) => isNodeSelected(value, nodeData)
        ) : isNodeSelected(props.modelValue, nodeData),
        "pagoda-select-tree-node--disabled": disabled,
        "pagoda-select-tree-node--leaf": isLeaf
      };
    }
    function isNodeSelected(selectedValue, nodeData) {
      selectedValue = getValue(selectedValue);
      const nodeValue = getValue(nodeData);
      return !isEmpty(selectedValue) && !isEmpty(nodeValue) && selectedValue === nodeValue;
    }
    function getValueFromData(data) {
      return props.bindObject ? data : data[props.valueKey];
    }
    function handleSelectInput(value) {
      emit(
        "update:modelValue",
        props.multiple ? value.map(
          (v) => getValueFromData(getNode(v).data)
        ) : value
      );
    }
    function handleTreeCheck(data, {
      checkedNodes
    }) {
      if (props.multiple && props.filterChildWhenSelectAll) {
        checkedNodes = getCheckedNodes(elTreeCtx.value, true);
      }
      emit(
        "update:modelValue",
        checkedNodes.map(
          (nodeData) => props.bindObject ? nodeData : getValue(nodeData)
        )
      );
    }
    function handleTreeNodeClick(data, node) {
      if (!props.multiple && !node.disabled) {
        emit("update:modelValue", getValueFromData(data));
        setTimeout(() => {
          var _a;
          (_a = elSelectCtx.value) == null ? void 0 : _a.handleOptionSelect(getElOptionFromNode(node));
        }, 0);
      }
    }
    function handleSelectVisibleChange(visible) {
      if (visible && props.filterable) {
        filterMethod("");
      }
    }
    function filterMethod(query) {
      elTreeCtx.value.filter(query);
    }
    function filterNodeMethod(value, data, node) {
      if (!value)
        return true;
      return node.label.indexOf(value) !== -1;
    }
    const __returned__ = { name, props, emit, elOptions, elSelectCtx, elTreeCtx, selectAttrs, treeAttrs, defaultExpanded, getValue, getNode, getElOption, getElOptionFromNode, getTreeNodeClass, isNodeSelected, getValueFromData, handleSelectInput, handleTreeCheck, handleTreeNodeClick, handleSelectVisibleChange, filterMethod, filterNodeMethod, get ElTree() {
      return ElTree;
    }, get ElSelect() {
      return ElSelect;
    }, get ElOption() {
      return ElOption;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderList as _renderList, Fragment as _Fragment, openBlock as _openBlock, createElementBlock as _createElementBlock, createBlock as _createBlock, createCommentVNode as _createCommentVNode, createVNode as _createVNode, normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, renderSlot as _renderSlot, toDisplayString as _toDisplayString, createElementVNode as _createElementVNode, normalizeClass as _normalizeClass, mergeProps as _mergeProps, withCtx as _withCtx } from "vue";
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createBlock($setup["ElSelect"], _mergeProps({
    ref: "elSelectCtx",
    class: "pagoda-select-tree",
    "model-value": _ctx.modelValue,
    "filter-method": $setup.filterMethod,
    placeholder: _ctx.placeholder,
    onVisibleChange: $setup.handleSelectVisibleChange,
    "onUpdate:modelValue": $setup.handleSelectInput
  }, $setup.selectAttrs, {
    multiple: _ctx.multiple,
    filterable: _ctx.filterable,
    "popper-class": "pagoda-select-tree-popper"
  }), {
    default: _withCtx(() => [
      (_openBlock(true), _createElementBlock(
        _Fragment,
        null,
        _renderList($setup.elOptions, (item) => {
          return _openBlock(), _createBlock($setup["ElOption"], {
            class: "pagoda-select-tree-popper__option",
            key: $setup.getValue(item.value),
            label: item.label,
            value: item.value
          }, null, 8, ["label", "value"]);
        }),
        128
        /* KEYED_FRAGMENT */
      )),
      _createCommentVNode(" \u7528\u4E00\u4E2A\u9690\u85CF\u7684 option \u6765\u4F7F el-select \u4E0D\u4F1A\u5C55\u793A\u7A7A\u6570\u636E\u72B6\u6001 "),
      _createVNode($setup["ElOption"], {
        class: "pagoda-select-tree-popper__option",
        value: "__pagoda-select-tree__option-placeholder__"
      }),
      _createVNode($setup["ElTree"], _mergeProps({
        ref: "elTreeCtx",
        data: _ctx.data,
        "default-expanded-keys": $setup.defaultExpanded,
        "show-checkbox": _ctx.multiple,
        "filter-node-method": $setup.filterNodeMethod,
        "expand-on-click-node": false,
        onNodeClick: $setup.handleTreeNodeClick,
        onCheck: $setup.handleTreeCheck
      }, $setup.treeAttrs), {
        default: _withCtx((slotProps) => [
          _createElementVNode(
            "span",
            {
              class: _normalizeClass(["pagoda-select-tree-node", $setup.getTreeNodeClass(slotProps.node)])
            },
            [
              _renderSlot(_ctx.$slots, "tree-node", _normalizeProps(_guardReactiveProps(slotProps)), () => [
                _createElementVNode(
                  "span",
                  null,
                  _toDisplayString(slotProps.node.label),
                  1
                  /* TEXT */
                )
              ])
            ],
            2
            /* CLASS */
          )
        ]),
        _: 3
        /* FORWARDED */
      }, 16, ["data", "default-expanded-keys", "show-checkbox"])
    ]),
    _: 3
    /* FORWARDED */
  }, 16, ["model-value", "placeholder", "multiple", "filterable"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
