var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { h, computed, defineComponent, inject, Fragment, watch, getCurrentInstance, createVNode as _createVNode, mergeProps as _mergeProps } from "vue";
import { tableColumnProps } from "./table-column-props.mjs";
import { ElTableColumn } from "element-plus/es/index.mjs";
import { isString, omit } from "lodash-unified";
import { isNumberString, isNumberExceptNaN, getTextWidth } from "pagoda-shared";
import { createNamespace } from "../../utils/index.mjs";
import { PagodaUiError } from "../../utils/error.mjs";
import { withPropsDefaults } from "pagoda-shared";
import { TABLE_INJECTION_KEY } from "../../table/src/types/index.mjs";
ElTableColumn.render = function() {
  var _a, _b, _c, _d;
  try {
    const renderDefault = (_b = (_a = this.$slots).default) == null ? void 0 : _b.call(_a, {
      row: {},
      column: {},
      $index: -1
    });
    const children = [];
    if (Array.isArray(renderDefault)) {
      for (const childNode of renderDefault) {
        if (((_c = childNode.type) == null ? void 0 : _c.name) === "ElTableColumn" || // 子节点的类型为 pagoda-table-column 时也要正常渲染
        ((_d = childNode.type) == null ? void 0 : _d.name) === "pagoda-table-column" || childNode.shapeFlag & 2) {
          children.push(childNode);
        } else if (childNode.type === Fragment && Array.isArray(childNode.children)) {
          childNode.children.forEach((vnode2) => {
            if ((vnode2 == null ? void 0 : vnode2.patchFlag) !== 1024 && !isString(vnode2 == null ? void 0 : vnode2.children)) {
              children.push(vnode2);
            }
          });
        }
      }
    }
    const vnode = h("div", children);
    return vnode;
  } catch (e) {
    return h("div", []);
  }
};
const extendColumnTypeCustomColumns = {};
const customColumns = {};
const Column = defineComponent({
  props: omit(tableColumnProps, ["column"]),
  setup(props, {
    slots,
    emit
  }) {
    const tableProvider = inject(TABLE_INJECTION_KEY);
    const isAutoMinWidth = computed(() => {
      return props.autoMinWidth && tableProvider.autoMinWidth.value;
    });
    if (props.type === "radio") {
      watch(() => props.reserveRadio, () => {
        tableProvider.reserveRadio = props.reserveRadio;
      }, {
        immediate: true
      });
    }
    return () => {
      const elTableColumnProps = __spreadValues({}, props);
      const elTableColumnSlots = __spreadValues({}, slots);
      if (isAutoMinWidth.value && props.label) {
        const labelWidth = getTextWidth(props.label, '700 14px / 23px "PingFang SC", "helvetica neue", "hiragino sans gb", arial, "microsoft yahei ui", "microsoft yahei", simsun, sans-serif');
        const tableColumnPaddingLeft = 12;
        const tableColumnPaddingRight = 12;
        const requiredIconWidth = props.required ? 12 : 0;
        if (!isNumberString(props.minWidth) && !isNumberExceptNaN(props.minWidth) && !isNumberString(props.width) && !isNumberExceptNaN(props.width)) {
          elTableColumnProps.minWidth = requiredIconWidth + tableColumnPaddingLeft + labelWidth + tableColumnPaddingRight + 2;
        }
      }
      if (elTableColumnProps.renderColumn && !elTableColumnSlots.default) {
        const {
          renderColumn
        } = elTableColumnProps;
        elTableColumnSlots.default = (slotProps) => {
          const {
            row,
            column
          } = slotProps;
          const cellValue = row[column.property];
          return renderColumn(__spreadProps(__spreadValues({
            cellValue,
            props: elTableColumnProps
          }, slotProps), {
            slots,
            emit,
            tableProvider
          }));
        };
      }
      if (elTableColumnProps.renderHeader && !elTableColumnSlots.header) {
        const {
          renderHeader
        } = elTableColumnProps;
        elTableColumnSlots.header = (slotProps) => {
          return renderHeader(__spreadProps(__spreadValues({
            props: elTableColumnProps
          }, slotProps), {
            slots,
            emit
          }));
        };
      }
      if (elTableColumnProps.required) {
        const requireClass = "column-required";
        const classes = elTableColumnProps.labelClassName;
        elTableColumnProps.labelClassName = classes ? `${classes} ${requireClass}` : requireClass;
      }
      return _createVNode(ElTableColumn, omit(elTableColumnProps, ["renderColumn", "renderHeader"]), elTableColumnSlots);
    };
  }
});
function registerColumn(type, config, columns = customColumns) {
  if (type in columns) {
    throw new PagodaUiError("Component TableColumn", `\u5F53\u524D\u6CE8\u518C\u7684\u5217\u7C7B\u578B\u5DF2\u5B58\u5728\uFF1A${type}`);
  }
  columns[type] = {
    component: defineComponent({
      props: withPropsDefaults(Object.assign({}, Column.props, config.props), config.defaultSet || {}),
      emits: config.emits,
      setup: Column.setup
    }),
    defaultSet: config.defaultSet
  };
}
const name = createNamespace("table-column");
var stdin_default = defineComponent({
  name,
  props: tableColumnProps,
  registerColumn,
  setup(props, {
    slots,
    attrs
  }) {
    const instance = getCurrentInstance();
    return () => {
      const customColumn = props.column ? customColumns[props.column] : extendColumnTypeCustomColumns[props.type];
      if (customColumn) {
        const CustomColumnComponent = customColumn.component;
        return _createVNode(CustomColumnComponent, _mergeProps(instance == null ? void 0 : instance.vnode.props, attrs), slots);
      }
      return _createVNode(Column, instance == null ? void 0 : instance.vnode.props, slots);
    };
  }
});
export {
  customColumns,
  stdin_default as default,
  extendColumnTypeCustomColumns,
  registerColumn
};
