var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { computed, inject, onBeforeMount, ref, watch } from "vue";
import { tableEditableCellProps } from "./tableEditableCell.mjs";
import { ElTooltip } from "element-plus/es/index.mjs";
import { TABLE_EDITABLE_INJECTION_KEY } from "../../table-editable/index.mjs";
import { PagodaUiError } from "../../utils/error.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("table-editable-cell");
const __default__ = {
  name
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: tableEditableCellProps,
  setup(__props, { expose: __expose }) {
    __expose();
    const tableEditableProvider = inject(TABLE_EDITABLE_INJECTION_KEY);
    if (!tableEditableProvider) {
      throw new PagodaUiError(
        "[Component TableEditableCell]",
        "\u8BE5\u7EC4\u4EF6\u5FC5\u987B\u7ED3\u5408 TableEditable \u7EC4\u4EF6\u4F7F\u7528"
      );
    }
    const props = __props;
    if (props.prop && !tableEditableProvider.editableColumns.value.includes(props.prop)) {
      throw new PagodaUiError(
        "[Component TableEditableCell]",
        `\u8BF7\u5728editable-columns\u5C5E\u6027\u4E2D\u914D\u7F6E\u8BE5\u5B57\u6BB5\uFF1A${props.prop}`
      );
    }
    const rowStates = ref({});
    const cellsStates = ref({});
    const validateMsgTooltip = computed(() => {
      return tableEditableProvider.validateMsgTooltip.value;
    });
    watch(
      [tableEditableProvider.tableData, () => props.row],
      () => {
        rowStates.value = props.row ? tableEditableProvider.store.getRowStates(props.row) || {} : {};
        cellsStates.value = props.row ? tableEditableProvider.store.getCellsStates(props.row) || {} : {};
      },
      {
        immediate: true
      }
    );
    const ownStates = computed(() => {
      return props.prop ? cellsStates.value[props.prop] || {} : {};
    });
    onBeforeMount(() => {
      if (props.dependencies) {
        props.dependencies(
          props.row,
          ownStates.value,
          cellsStates.value,
          rowStates.value
        );
      }
    });
    function validateOwn(cb) {
      if (!props.prop)
        return;
      tableEditableProvider.validateCells([props.row], [props.prop], cb);
    }
    const __returned__ = { name, tableEditableProvider, props, rowStates, cellsStates, validateMsgTooltip, ownStates, validateOwn, get ElTooltip() {
      return ElTooltip;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, createElementVNode as _createElementVNode, withCtx as _withCtx, openBlock as _openBlock, createBlock as _createBlock, createCommentVNode as _createCommentVNode, createElementBlock as _createElementBlock, toDisplayString as _toDisplayString, vShow as _vShow, withDirectives as _withDirectives, normalizeClass as _normalizeClass } from "vue";
const _hoisted_1 = { class: "pagoda-table-editable-cell__content" };
const _hoisted_2 = {
  key: 1,
  class: "pagoda-table-editable-cell__content"
};
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-table-editable-cell", { "is-validate-error": !!$setup.ownStates.validateMsg }]),
      onMouseenter: _cache[0] || (_cache[0] = () => $setup.ownStates.hovering = true),
      onMouseleave: _cache[1] || (_cache[1] = () => $setup.ownStates.hovering = false)
    },
    [
      $setup.validateMsgTooltip ? (_openBlock(), _createBlock($setup["ElTooltip"], {
        key: 0,
        visible: !!$setup.ownStates.validateMsg && $setup.ownStates.hovering,
        "popper-class": "pagoda-table-editable-cell-validate-msg",
        effect: "light",
        content: $setup.ownStates.validateMsg,
        placement: "top-start",
        manual: ""
      }, {
        default: _withCtx(() => [
          _createElementVNode("div", _hoisted_1, [
            _renderSlot(_ctx.$slots, "default", {
              cellsStates: $setup.cellsStates,
              rowStates: $setup.rowStates,
              ownStates: $setup.ownStates,
              validateOwn: $setup.validateOwn
            })
          ])
        ]),
        _: 3
        /* FORWARDED */
      }, 8, ["visible", "content"])) : (_openBlock(), _createElementBlock("div", _hoisted_2, [
        _renderSlot(_ctx.$slots, "default", {
          cellsStates: $setup.cellsStates,
          rowStates: $setup.rowStates,
          ownStates: $setup.ownStates,
          validateOwn: $setup.validateOwn
        })
      ])),
      !$setup.validateMsgTooltip ? _withDirectives((_openBlock(), _createElementBlock(
        "div",
        {
          key: 2,
          class: "pagoda-table-editable-cell__error-msg"
        },
        _toDisplayString($setup.ownStates.validateMsg),
        513
        /* TEXT, NEED_PATCH */
      )), [
        [_vShow, !!$setup.ownStates.validateMsg]
      ]) : _createCommentVNode("v-if", true)
    ],
    34
    /* CLASS, NEED_HYDRATION */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
