import { reactive } from "vue";
function useTableRadio() {
  const radio = reactive({
    selected: null,
    selectedIdx: -1
  });
  function clearRadio() {
    radio.selectedIdx = -1;
    radio.selected = null;
  }
  function setRadio(val) {
    radio.selected = val.selected;
    radio.selectedIdx = val.selectedIdx;
  }
  return {
    radio,
    clearRadio,
    setRadio
  };
}
export {
  useTableRadio
};
