var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import { defineComponent, mergeProps as _mergeProps, createVNode as _createVNode } from "vue";
import { TableColumn } from "../../table-column/index.mjs";
import { customColumns } from "../../table-column/src/table-column.mjs";
import { GET_EMPTY_ARR, GET_EMPTY_OBJ } from "pagoda-shared";
function getSlotKey(column) {
  return column.slot || column.prop;
}
function renderColumn(column, slots) {
  column = __spreadValues({}, column);
  delete column.children;
  return _createVNode(TableColumn, _mergeProps(column, {
    "key": Symbol()
  }), slots);
}
function renderColumns(columns, slots) {
  return columns.map((column) => {
    var _a, _b, _c;
    if (!column.slot && column.column) {
      column.slot = (_b = (_a = customColumns[column.column]) == null ? void 0 : _a.defaultSet) == null ? void 0 : _b.slot;
    }
    const slotKey = getSlotKey(column);
    const defaultRenderCell = function() {
      return renderColumns(column.children, slots);
    };
    const renderCell = slotKey && slots[slotKey] || ((_c = column.children) == null ? void 0 : _c.length) && defaultRenderCell || void 0;
    const renderHeader = slotKey ? slots[`${slotKey}-header`] : void 0;
    return renderColumn(column, {
      default: renderCell,
      header: renderHeader
    });
  });
}
var stdin_default = defineComponent({
  props: {
    columns: {
      type: Array,
      default: GET_EMPTY_ARR
    },
    slots: {
      type: Object,
      default: GET_EMPTY_OBJ
    }
  },
  setup(props) {
    return () => {
      return renderColumns(props.columns, props.slots);
    };
  }
});
export {
  stdin_default as default
};
