var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, provide, useSlots, watch, onBeforeMount } from "vue";
import { tableProps } from "./table.mjs";
import elTableProps from "element-plus/es/components/table/src/table/defaults.mjs";
import { isFunction } from "lodash-unified";
import { addUnit, isEmpty, getAttrByKey } from "pagoda-shared";
import { isArray } from "lodash-unified";
import Mitt from "mitt";
import RenderTableColumns from "./render-table-columns.mjs";
import { ElTable, ElPagination } from "element-plus/es/index.mjs";
import { TABLE_INJECTION_KEY } from "./types/index.mjs";
import { usePickProps } from "pagoda-shared";
import { useTableRequest } from "./composables/use-table-request.mjs";
import { useTableRadio } from "./composables/use-table-radio.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("table");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: tableProps,
  emits: ["radio-change"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const slots = useSlots();
    const mitter = Mitt();
    const elTableCtx = ref();
    const {
      tableData,
      pagination,
      refresh,
      refreshCurrentPage,
      setTableSortable,
      setPaginationCurrentPage,
      setPaginationSize
    } = useTableRequest({
      initialPagination: {
        pageSize: getAttrByKey(
          props.pagination,
          "defaultPageSize"
        ) || getAttrByKey(
          props.pagination,
          "pageSize"
        ) || 10
      },
      onRequest(...arg) {
        var _a, _b;
        (_a = props.onRequest) == null ? void 0 : _a.call(props, ...arg);
        return (_b = props.request) == null ? void 0 : _b.call(props, ...arg);
      }
    });
    const { radio, setRadio, clearRadio } = useTableRadio();
    const elTableAttrs = usePickProps(props, elTableProps, {
      ignoreClassAndStyle: true
    });
    const flexLayout = computed(() => {
      return Boolean(props.wrapperHeight);
    });
    const elTableHeightComputed = computed(() => {
      return !isEmpty(props.height) ? props.height : flexLayout.value ? "100%" : void 0;
    });
    const paginationConfig = computed(() => {
      return Object.assign(
        {
          show: true,
          layout: "total, sizes, prev, pager, next, jumper",
          background: true
        },
        {
          total: pagination.total
        },
        props.pagination
      );
    });
    const elTableSlots = computed(() => {
      return ["append", "empty"].filter((name2) => slots[name2]);
    });
    const tableDataComputed = computed(() => {
      return isArray(props.data) ? props.data : tableData.value;
    });
    const hasPagination = computed(() => {
      return paginationConfig.value.show && (props.request || props.onRequest);
    });
    watch(
      () => radio.selected,
      () => {
        emit("radio-change", radio.selected);
      }
    );
    watch(tableDataComputed, () => {
      if (!tableProvider.reserveRadio) {
        clearRadio();
      } else {
        setCurrentRadioByRow(radio.selected);
      }
    });
    onBeforeMount(() => {
      if (props.autoRequest)
        refresh();
      mitter.on("pagoda-table:radio-change", setRadio);
    });
    function handleSortChange(sortable) {
      if (sortable.column.sortable === "remote") {
        setTableSortable(sortable);
      }
    }
    function findRow(row) {
      let rowIndex = -1;
      const matchRow = tableDataComputed.value.find((rowData, idx) => {
        if (props.rowKey) {
          const rowKey = isFunction(props.rowKey) ? props.rowKey(rowData) : props.rowKey;
          if (rowKey) {
            if (rowData[rowKey] === row[rowKey]) {
              rowIndex = idx;
              return true;
            }
            ;
          }
        }
        if (rowData === row) {
          rowIndex = idx;
          return true;
        }
      });
      return {
        matchRow,
        rowIndex
      };
    }
    function setCurrentRadioByRow(row) {
      const { rowIndex } = findRow(row);
      setRadio({
        selectedIdx: rowIndex,
        selected: row
      });
    }
    const tableProvider = {
      mitter,
      radio,
      reserveRadio: false,
      autoMinWidth: computed(() => props.autoMinWidth)
    };
    provide(TABLE_INJECTION_KEY, tableProvider);
    __expose({
      elTableCtx,
      // functions
      refresh,
      refreshCurrentPage,
      setCurrentRadio: setCurrentRadioByRow,
      clearRadio
    });
    const __returned__ = { name, props, emit, slots, mitter, elTableCtx, tableData, pagination, refresh, refreshCurrentPage, setTableSortable, setPaginationCurrentPage, setPaginationSize, radio, setRadio, clearRadio, elTableAttrs, flexLayout, elTableHeightComputed, paginationConfig, elTableSlots, tableDataComputed, hasPagination, handleSortChange, findRow, setCurrentRadioByRow, tableProvider, get addUnit() {
      return addUnit;
    }, get RenderTableColumns() {
      return RenderTableColumns;
    }, get ElTable() {
      return ElTable;
    }, get ElPagination() {
      return ElPagination;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { createCommentVNode as _createCommentVNode, openBlock as _openBlock, createBlock as _createBlock, renderSlot as _renderSlot, Fragment as _Fragment, createElementBlock as _createElementBlock, normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, mergeProps as _mergeProps, withCtx as _withCtx, renderList as _renderList, createSlots as _createSlots, createVNode as _createVNode, createElementVNode as _createElementVNode, normalizeClass as _normalizeClass, normalizeStyle as _normalizeStyle } from "vue";
const _hoisted_1 = { class: "pagoda-table__el-table-wrapper" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-table", [{
        "pagoda-table--flex-column": $setup.flexLayout
      }, _ctx.$attrs.class]]),
      style: _normalizeStyle(__spreadValues({
        height: $setup.addUnit(_ctx.wrapperHeight)
      }, _ctx.$attrs.style || {}))
    },
    [
      _createElementVNode("div", _hoisted_1, [
        _createVNode($setup["ElTable"], _mergeProps($setup.elTableAttrs, {
          height: $setup.elTableHeightComputed,
          data: $setup.tableDataComputed,
          onSortChange: $setup.handleSortChange,
          ref: "elTableCtx"
        }), _createSlots({
          default: _withCtx(() => [
            _ctx.columns ? (_openBlock(), _createBlock($setup["RenderTableColumns"], {
              key: 0,
              columns: _ctx.columns,
              slots: $setup.slots
            }, null, 8, ["columns", "slots"])) : (_openBlock(), _createElementBlock(
              _Fragment,
              { key: 1 },
              [
                _createCommentVNode(" \u63D2\u69FD\u76F4\u63A5\u4F20\u5165table-column "),
                _renderSlot(_ctx.$slots, "default")
              ],
              2112
              /* STABLE_FRAGMENT, DEV_ROOT_FRAGMENT */
            ))
          ]),
          _: 2
          /* DYNAMIC */
        }, [
          _renderList($setup.elTableSlots, (slotName) => {
            return {
              name: slotName,
              fn: _withCtx((scope) => [
                _renderSlot(_ctx.$slots, slotName, _normalizeProps(_guardReactiveProps(scope)))
              ])
            };
          })
        ]), 1040, ["height", "data"])
      ]),
      _renderSlot(_ctx.$slots, "after-table"),
      $setup.hasPagination ? (_openBlock(), _createBlock($setup["ElPagination"], _mergeProps({ key: 0 }, $setup.paginationConfig, {
        ref: "elPaginationCtx",
        class: "pagoda-pagination",
        "current-page": $setup.pagination.currentPage,
        "onUpdate:currentPage": $setup.setPaginationCurrentPage,
        "onUpdate:pageSize": $setup.setPaginationSize
      }), null, 16, ["current-page", "onUpdate:currentPage", "onUpdate:pageSize"])) : _createCommentVNode("v-if", true)
    ],
    6
    /* CLASS, STYLE */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
