function getCheckedNodes(elTreeCtx, onlyData) {
  const checkedNodes = [];
  const { nodesMap } = elTreeCtx.store;
  Object.keys(nodesMap).forEach((nodeKey) => {
    const node = nodesMap[nodeKey];
    if (Object.prototype.hasOwnProperty.call(nodesMap, nodeKey) && node.checked && !(node.parent && node.parent.checked)) {
      checkedNodes.push(onlyData ? node.data : node);
    }
  });
  return checkedNodes;
}
export {
  getCheckedNodes
};
