import { camelCase } from "lodash-unified";
import { prefix } from "./constants.mjs";
function objectFromArray(arr, generatorValue) {
  const obj = {};
  arr.forEach((key) => {
    obj[key] = generatorValue(key);
  });
  return obj;
}
function withInstall(options, extraInstall) {
  options.install = (app, config) => {
    const { name } = options;
    app.component(name, options);
    app.component(camelCase(`-${name}`), options);
    if (extraInstall)
      extraInstall(app, config);
  };
  return options;
}
function createNamespace(name) {
  const prefixedName = `${prefix}-${name}`;
  return prefixedName;
}
export {
  createNamespace,
  objectFromArray,
  withInstall
};
