import { mergeProps as _mergeProps, createVNode as _createVNode } from "vue";
import { ElCheckbox } from "element-plus/es/index.mjs";
function SelectionColumn(store, selectable) {
  return {
    width: 48,
    cellRenderer: (slotProps) => {
      return _createVNode(ElCheckbox, _mergeProps({
        "disabled": selectable == null ? void 0 : selectable(slotProps.rowData, slotProps.rowIndex),
        "modelValue": store.isSelected(slotProps.rowData),
        "onChange": () => {
          store.toggleRowSelection(slotProps.rowData);
          store.updateAllSelected();
        }
      }, {
        onClick: (event) => event.stopPropagation()
      }), null);
    },
    headerCellRenderer: () => {
      return _createVNode(ElCheckbox, {
        "disabled": store.tableData.value && store.tableData.value.length === 0,
        "indeterminate": store.selection.value.length > 0 && !store.isAllSelected.value,
        "modelValue": store.isAllSelected.value,
        "onUpdate:modelValue": () => store.toggleAllSelection()
      }, null);
    }
  };
}
export {
  SelectionColumn as default
};
