var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { h, Fragment, useSlots, computed } from "vue";
import SelectionColumn from "../columns/selection.mjs";
import IndexColumn from "../columns/index.mjs";
import { v4 as uuidv4 } from "uuid";
function useColumns({
  columns,
  store
}) {
  const slots = useSlots();
  const orignalColumns = computed(() => {
    return columns.value.map((column) => {
      var _a, _b, _c;
      const slotKey = column.slot || column.prop;
      const headerSlotKey = `${slotKey}-header`;
      let defaultColumn;
      switch (column.type) {
        case "selection":
          defaultColumn = SelectionColumn(store.value, column.selectable);
          break;
        case "index":
          defaultColumn = IndexColumn();
          break;
      }
      const tableColumn = Object.assign({}, defaultColumn, __spreadProps(__spreadValues({}, column), {
        key: (_a = column.key) != null ? _a : uuidv4(),
        dataKey: (_b = column.dataKey) != null ? _b : column.prop,
        title: (_c = column.title) != null ? _c : column.label
      }));
      if (slotKey && slots[slotKey]) {
        tableColumn.cellRenderer = (...args) => {
          return h(Fragment, slots[slotKey](...args));
        };
      }
      if (slotKey && slots[headerSlotKey]) {
        tableColumn.headerCellRenderer = (...args) => {
          return h(Fragment, slots[headerSlotKey](...args));
        };
      }
      return tableColumn;
    });
  });
  const selectable = computed(() => {
    var _a;
    return (_a = columns.value.find((column) => column.type === "selection")) == null ? void 0 : _a.selectable;
  });
  return {
    selectable,
    orignalColumns
  };
}
export {
  useColumns
};
