var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defineComponent as _defineComponent } from "vue";
import { ref, computed, useSlots, onBeforeMount } from "vue";
import { tableV2Props } from "element-plus/es/index.mjs";
import { virtualTableProps } from "./virtualTable.mjs";
import { addUnit, isEmpty } from "pagoda-shared";
import { isArray } from "lodash-unified";
import { getAttrByKey } from "pagoda-shared";
import { pick } from "lodash-unified";
import { ElTableV2, ElPagination, ElAutoResizer } from "element-plus/es/index.mjs";
import { useTableRequest } from "../../table/index.mjs";
import { usePickProps } from "pagoda-shared";
import { useSelection } from "./composables/use-selection.mjs";
import { useColumns } from "./composables/use-columns.mjs";
import { createNamespace } from "../../utils/index.mjs";
const name = createNamespace("virtual-table");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ _defineComponent(__spreadProps(__spreadValues({}, __default__), {
  props: virtualTableProps,
  emits: ["selection-change"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const slots = useSlots();
    const elTableV2Ctx = ref();
    const elTableV2Attrs = usePickProps(props, tableV2Props, {
      ignoreClassAndStyle: true
    });
    const {
      tableData,
      pagination,
      refresh,
      refreshCurrentPage,
      setPaginationCurrentPage,
      setPaginationSize
    } = useTableRequest({
      initialPagination: {
        pageSize: getAttrByKey(
          props.pagination,
          "defaultPageSize"
        ) || getAttrByKey(
          props.pagination,
          "pageSize"
        ) || 10
      },
      onRequest(...arg) {
        var _a, _b;
        (_a = props.onRequest) == null ? void 0 : _a.call(props, ...arg);
        return (_b = props.request) == null ? void 0 : _b.call(props, ...arg);
      }
    });
    const flexLayout = computed(() => {
      return Boolean(props.wrapperHeight);
    });
    const elTableHeightComputed = computed(() => {
      return !isEmpty(props.height) ? props.height : flexLayout.value ? "100%" : void 0;
    });
    const paginationConfig = computed(() => {
      return Object.assign(
        {
          show: true,
          layout: "total, sizes, prev, pager, next, jumper",
          background: true
        },
        {
          total: pagination.total
        },
        props.pagination
      );
    });
    const elTableSlots = computed(() => {
      return ["cell", "header", "header-cell", "row", "footer", "overlay"].filter(
        (name2) => slots[name2]
      );
    });
    const tableDataComputed = computed(() => {
      return isArray(props.data) ? props.data : tableData.value;
    });
    const hasPagination = computed(() => {
      return paginationConfig.value.show && (props.request || props.onRequest);
    });
    onBeforeMount(() => {
      if (props.autoRequest)
        refresh();
    });
    const { orignalColumns, selectable } = useColumns({
      columns: computed(() => props.columns),
      store: computed(() => {
        return __spreadValues({
          tableData: tableDataComputed
        }, selectionStore);
      })
    });
    const selectionStore = useSelection({
      tableData: tableDataComputed,
      selectable,
      onSelectionChange(selection) {
        emit("selection-change", selection);
      }
    });
    __expose(__spreadProps(__spreadValues({
      elTableV2Ctx,
      tableData: tableDataComputed,
      // functions
      refresh,
      refreshCurrentPage
    }, pick(selectionStore, [
      "selection",
      "isAllSelected",
      "getSelectionRows",
      "clearSelection",
      "toggleAllSelection"
    ])), {
      toggleRowSelection(row, selected) {
        selectionStore.toggleRowSelection(row, selected);
        selectionStore.updateAllSelected();
      }
    }));
    const __returned__ = { name, props, emit, slots, elTableV2Ctx, elTableV2Attrs, tableData, pagination, refresh, refreshCurrentPage, setPaginationCurrentPage, setPaginationSize, flexLayout, elTableHeightComputed, paginationConfig, elTableSlots, tableDataComputed, hasPagination, orignalColumns, selectable, selectionStore, get addUnit() {
      return addUnit;
    }, get ElTableV2() {
      return ElTableV2;
    }, get ElPagination() {
      return ElPagination;
    }, get ElAutoResizer() {
      return ElAutoResizer;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
import { renderSlot as _renderSlot, toDisplayString as _toDisplayString, createElementVNode as _createElementVNode, createCommentVNode as _createCommentVNode, normalizeProps as _normalizeProps, guardReactiveProps as _guardReactiveProps, mergeProps as _mergeProps, withCtx as _withCtx, renderList as _renderList, createSlots as _createSlots, createVNode as _createVNode, normalizeStyle as _normalizeStyle, openBlock as _openBlock, createBlock as _createBlock, normalizeClass as _normalizeClass, createElementBlock as _createElementBlock } from "vue";
const _hoisted_1 = { class: "pagoda-virtual-table__el-virtual-table-wrapper" };
const _hoisted_2 = {
  class: "el-table__empty-block",
  style: { "height": "100%" }
};
const _hoisted_3 = { class: "el-table__empty-text" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return _openBlock(), _createElementBlock(
    "div",
    {
      class: _normalizeClass(["pagoda-virtual-table", [{
        "pagoda-virtual-table--flex-column": $setup.flexLayout
      }, _ctx.$attrs.class]]),
      style: _normalizeStyle(__spreadValues({
        height: $setup.addUnit(_ctx.wrapperHeight)
      }, _ctx.$attrs.style || {}))
    },
    [
      _createElementVNode("div", _hoisted_1, [
        _createVNode($setup["ElAutoResizer"], {
          style: _normalizeStyle({ height: $setup.addUnit($setup.elTableHeightComputed) })
        }, {
          default: _withCtx((size) => [
            _createVNode($setup["ElTableV2"], _mergeProps($setup.elTableV2Attrs, {
              "footer-height": !$setup.tableDataComputed.length ? 1 : _ctx.footerHeight,
              columns: $setup.orignalColumns,
              width: size.width,
              height: size.height,
              data: $setup.tableDataComputed,
              ref: "elTableV2Ctx"
            }), _createSlots({
              empty: _withCtx(() => [
                _renderSlot(_ctx.$slots, "empty", {}, () => [
                  _createElementVNode("div", _hoisted_2, [
                    _createElementVNode(
                      "div",
                      _hoisted_3,
                      _toDisplayString(_ctx.emptyText),
                      1
                      /* TEXT */
                    )
                  ])
                ])
              ]),
              _: 2
              /* DYNAMIC */
            }, [
              _renderList($setup.elTableSlots, (slotName) => {
                return {
                  name: slotName,
                  fn: _withCtx((scope) => [
                    _renderSlot(_ctx.$slots, slotName, _normalizeProps(_guardReactiveProps(scope)))
                  ])
                };
              })
            ]), 1040, ["footer-height", "columns", "width", "height", "data"])
          ]),
          _: 3
          /* FORWARDED */
        }, 8, ["style"])
      ]),
      _renderSlot(_ctx.$slots, "after-table"),
      $setup.hasPagination ? (_openBlock(), _createBlock($setup["ElPagination"], _mergeProps({ key: 0 }, $setup.paginationConfig, {
        ref: "elPaginationCtx",
        class: "pagoda-pagination",
        "current-page": $setup.pagination.currentPage,
        "onUpdate:currentPage": $setup.setPaginationCurrentPage,
        "onUpdate:pageSize": $setup.setPaginationSize
      }), null, 16, ["current-page", "onUpdate:currentPage", "onUpdate:pageSize"])) : _createCommentVNode("v-if", true)
    ],
    6
    /* CLASS, STYLE */
  );
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
export {
  stdin_default as default
};
