var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_vue2 = require("vue");
var import_dialogForm = require("./dialogForm");
var import_lib = require("element-plus/lib/index.js");
var import_pagoda_shared = require("pagoda-shared");
var import_lodash_unified = require("lodash-unified");
var import_constants = require("../../utils/constants");
var import_pagoda_shared2 = require("pagoda-shared");
var import_utils = require("../../utils");
var import_vue3 = require("vue");
const name = (0, import_utils.createNamespace)("dialog-form");
const __default__ = {
  name,
  inheritAttrs: false
};
const __vue_sfc__ = /* @__PURE__ */ (0, import_vue.defineComponent)(__spreadProps(__spreadValues({}, __default__), {
  props: import_dialogForm.dialogFormProps,
  emits: ["update:modelValue", "save"],
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const attrs = (0, import_pagoda_shared.useAttrsIgnore)();
    const emit = __emit;
    let defaultFormData;
    const dialogAction = (0, import_vue2.ref)("create");
    const dialogVisible = (0, import_vue2.ref)(false);
    const formSubmiting = (0, import_vue2.ref)(false);
    const elFormCtx = (0, import_vue2.ref)();
    const elDialogProps = (0, import_vue2.computed)(() => {
      return Object.assign(
        {},
        {
          width: "500px"
        },
        props.dialogProps
      );
    });
    const title = (0, import_vue2.computed)(() => {
      return dialogAction.value === "create" ? props.createDialogTitle : props.editDialogTitle;
    });
    const isEditMode = (0, import_vue2.computed)(() => {
      return dialogAction.value === "edit";
    });
    function onElFormMounted() {
      defaultFormData = (0, import_lodash_unified.cloneDeep)(props.modelValue);
    }
    function create() {
      return __async(this, null, function* () {
        yield show("create");
        emit("update:modelValue", (0, import_lodash_unified.cloneDeep)(defaultFormData));
        yield (0, import_vue2.nextTick)();
        if (elFormCtx.value)
          elFormCtx.value.clearValidate();
      });
    }
    function edit(data) {
      return __async(this, null, function* () {
        yield show("edit");
        emit("update:modelValue", (0, import_lodash_unified.cloneDeep)(data));
        yield (0, import_vue2.nextTick)();
        if (elFormCtx.value)
          elFormCtx.value.clearValidate();
      });
    }
    function show(action) {
      return __async(this, null, function* () {
        dialogAction.value = action;
        dialogVisible.value = true;
        yield (0, import_vue2.nextTick)();
      });
    }
    function handleCancel() {
      const beforeClose = (0, import_pagoda_shared2.getAttrByKey)(
        props.dialogProps || {},
        "beforeClose"
      );
      if (beforeClose) {
        beforeClose(closeDialog);
      } else {
        closeDialog();
      }
    }
    function handleDialogClosed() {
      elFormCtx.value.clearValidate();
    }
    function closeLoading() {
      formSubmiting.value = false;
    }
    function closeDialog() {
      dialogVisible.value = false;
    }
    function handleSave() {
      return __async(this, null, function* () {
        if (attrs.value.rules) {
          yield elFormCtx.value.validate();
        }
        formSubmiting.value = true;
        emit("save", dialogAction.value, closeLoading, closeDialog);
      });
    }
    __expose({
      create,
      edit,
      elFormCtx
    });
    const __returned__ = { name, props, attrs, emit, get defaultFormData() {
      return defaultFormData;
    }, set defaultFormData(v) {
      defaultFormData = v;
    }, dialogAction, dialogVisible, formSubmiting, elFormCtx, elDialogProps, title, isEditMode, onElFormMounted, create, edit, show, handleCancel, handleDialogClosed, closeLoading, closeDialog, handleSave, get ElDialog() {
      return import_lib.ElDialog;
    }, get ElForm() {
      return import_lib.ElForm;
    }, get ElButton() {
      return import_lib.ElButton;
    }, get PAGODA() {
      return import_constants.PAGODA;
    } };
    Object.defineProperty(__returned__, "__isScriptSetup", { enumerable: false, value: true });
    return __returned__;
  }
}));
const _hoisted_1 = { class: "dialog-footer" };
function __vue_render__(_ctx, _cache, $props, $setup, $data, $options) {
  return (0, import_vue3.openBlock)(), (0, import_vue3.createBlock)($setup["ElDialog"], (0, import_vue3.mergeProps)({
    ref: "elDialogCtx",
    modelValue: $setup.dialogVisible,
    "onUpdate:modelValue": _cache[1] || (_cache[1] = ($event) => $setup.dialogVisible = $event),
    "close-on-click-modal": false,
    "close-on-press-escape": false,
    "append-to-body": ""
  }, $setup.elDialogProps, {
    title: $setup.title,
    onClosed: $setup.handleDialogClosed
  }), {
    footer: (0, import_vue3.withCtx)(() => [
      (0, import_vue3.createElementVNode)("div", _hoisted_1, [
        (0, import_vue3.createVNode)($setup["ElButton"], { onClick: $setup.handleCancel }, {
          default: (0, import_vue3.withCtx)(() => [
            (0, import_vue3.createTextVNode)(
              (0, import_vue3.toDisplayString)(_ctx.cancelBtnText),
              1
              /* TEXT */
            )
          ]),
          _: 1
          /* STABLE */
        }),
        (0, import_vue3.createVNode)($setup["ElButton"], {
          loading: $setup.formSubmiting,
          type: "primary",
          onClick: $setup.handleSave
        }, {
          default: (0, import_vue3.withCtx)(() => [
            (0, import_vue3.createTextVNode)(
              (0, import_vue3.toDisplayString)(_ctx.submitBtnText),
              1
              /* TEXT */
            )
          ]),
          _: 1
          /* STABLE */
        }, 8, ["loading"])
      ])
    ]),
    default: (0, import_vue3.withCtx)(() => [
      (0, import_vue3.createVNode)($setup["ElForm"], (0, import_vue3.mergeProps)({
        ref: "elFormCtx",
        onVnodeMounted: $setup.onElFormMounted,
        model: _ctx.modelValue,
        "label-width": `${$setup.PAGODA.form.labelWidth}px`
      }, _ctx.$attrs, {
        onSubmit: _cache[0] || (_cache[0] = (0, import_vue3.withModifiers)(() => {
        }, ["prevent"]))
      }), {
        default: (0, import_vue3.withCtx)(() => [
          (0, import_vue3.renderSlot)(_ctx.$slots, "default", { isEditMode: $setup.isEditMode })
        ]),
        _: 3
        /* FORWARDED */
      }, 16, ["model", "label-width"]),
      (0, import_vue3.renderSlot)(_ctx.$slots, "other")
    ]),
    _: 3
    /* FORWARDED */
  }, 16, ["modelValue", "title"]);
}
__vue_sfc__.render = __vue_render__;
var stdin_default = __vue_sfc__;
