var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var stdin_exports = {};
__export(stdin_exports, {
  extraRouteInfo: () => extraRouteInfo,
  getRouteNamesFromTab: () => getRouteNamesFromTab,
  getTabConfig: () => getTabConfig,
  injectRouteRelation: () => injectRouteRelation,
  useLayoutWithRouter: () => useLayoutWithRouter
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_pagoda_shared = require("pagoda-shared");
var import_router = require("./router");
var import_lodash_unified = require("lodash-unified");
function injectRouteRelation(routesMap, route) {
  var _a, _b;
  if (!route.meta) {
    route.meta = {
      childRoutes: []
    };
  }
  if (!route.meta.childRoutes) {
    route.meta.childRoutes = [];
  }
  const { meta } = route;
  let rootRoute = route;
  if (meta.parentRouteName) {
    const parentRoute = routesMap[meta.parentRouteName];
    rootRoute = injectRouteRelation(routesMap, parentRoute);
    (_b = (_a = parentRoute.meta) == null ? void 0 : _a.childRoutes) == null ? void 0 : _b.push(route);
  }
  meta.rootRoute = rootRoute;
  return rootRoute;
}
function extraRouteInfo(routes) {
  const routesMap = (0, import_pagoda_shared.getMapFromTree)(routes, "name", "children").map;
  Object.keys(routesMap).forEach((routeName) => {
    const route = routesMap[routeName];
    (0, import_router.injectRouteComponentName)(route);
    injectRouteRelation(routesMap, route);
  });
}
function getRouteNamesFromTab(tabs, routesMap) {
  return Object.keys(routesMap).filter((routeName) => {
    const route = routesMap[routeName];
    return tabs.some((tab) => {
      var _a, _b;
      return ((_b = (_a = route.meta) == null ? void 0 : _a.rootRoute) == null ? void 0 : _b.name) === tab.name;
    });
  });
}
function getChildRouteNamesDeep(route) {
  var _a, _b;
  const names = [];
  (_b = (_a = route.meta) == null ? void 0 : _a.childRoutes) == null ? void 0 : _b.forEach((r) => {
    names.push(r.name);
    names.push(...getChildRouteNamesDeep(r));
  });
  return names;
}
function getTabConfig(route) {
  const { tabLabel, tabCloseable = true } = route.meta;
  return {
    tabLabel,
    tabCloseable
  };
}
function getConfigFromRouteAndMenu(route, sideMenusMap, menuTitleKey) {
  const routeMeta = route.meta;
  const rootRoute = routeMeta.rootRoute;
  const config = {
    rootRoute
  };
  if (rootRoute) {
    const activeMenuIndex = rootRoute.name;
    const activeMenu = sideMenusMap[activeMenuIndex];
    const { tabLabel, tabCloseable } = Object.assign(
      getTabConfig(rootRoute),
      getTabConfig(route)
    );
    if (activeMenu) {
      config.activeMenu = activeMenu;
    }
    config.tabLabel = tabLabel || activeMenu && activeMenu[menuTitleKey];
    config.tabName = rootRoute.name;
    config.tabCloseable = tabCloseable;
  }
  return config;
}
function useLayoutWithRouter({
  router,
  menuConfig,
  keepAlive
}) {
  const sideMenusMap = {};
  const activeMenuIndex = (0, import_vue.ref)("");
  const activeTab = (0, import_vue.ref)();
  const keepAliveRouteNames = (0, import_vue.ref)([]);
  const defaultTabs = [];
  const menuIndexKey = (0, import_lodash_unified.get)(menuConfig, "menuIndexKey", "index");
  const menuTitleKey = (0, import_lodash_unified.get)(menuConfig, "menuTitleKey", "title");
  const menuChildrenKey = (0, import_lodash_unified.get)(menuConfig, "menuChildrenKey", "children");
  (0, import_pagoda_shared.loopTree)(router.options.routes, "children", (item) => {
    var _a;
    if (item.name && ((_a = item.meta) == null ? void 0 : _a.tabCloseable) === false) {
      const { tabLabel, tabName, tabCloseable, rootRoute } = getConfigFromRouteAndMenu(item, sideMenusMap, menuTitleKey);
      if (tabLabel && tabName) {
        defaultTabs.push({
          label: tabLabel,
          name: tabName,
          closable: tabCloseable,
          rootRoute,
          route: item
        });
      }
    }
  });
  const handleRouteChange = function(route) {
    const { activeMenu, tabLabel, tabName, rootRoute, tabCloseable } = getConfigFromRouteAndMenu(route, sideMenusMap, menuTitleKey);
    if (activeMenu) {
      activeMenuIndex.value = activeMenu.index;
    } else {
      activeMenuIndex.value = "";
    }
    if (tabLabel && tabName) {
      activeTab.value = {
        label: tabLabel,
        name: tabName,
        route,
        closable: tabCloseable,
        rootRoute
      };
    } else {
      activeTab.value = void 0;
    }
  };
  (0, import_vue.watch)(
    () => menuConfig.sideMenus,
    () => {
      if (menuConfig.sideMenus) {
        Object.assign(
          sideMenusMap,
          (0, import_pagoda_shared.getMapFromTree)(menuConfig.sideMenus, menuIndexKey, menuChildrenKey).map
        );
      }
      if (router.currentRoute.value) {
        handleRouteChange(router.currentRoute.value);
      }
    },
    {
      immediate: true
    }
  );
  (0, import_vue.watch)(
    router.currentRoute,
    (to) => __async(this, null, function* () {
      handleRouteChange(to);
      if (keepAlive) {
        if (to.name && to.meta.keepAlive !== false && !keepAliveRouteNames.value.some((name) => name === to.name)) {
          yield (0, import_vue.nextTick)();
          keepAliveRouteNames.value.push(to.name);
        }
        if (to.name) {
          const childrenRouteNames = getChildRouteNamesDeep(to);
          keepAliveRouteNames.value = keepAliveRouteNames.value.filter(
            (name) => !childrenRouteNames.some(
              (childRouteName) => childRouteName === name
            )
          );
        }
      }
    }),
    {
      immediate: true
    }
  );
  const clearRemoveTabsKeepAlive = function(removeTabsConfig) {
    const routesMap = (0, import_pagoda_shared.getMapFromTree)(
      // @ts-ignore
      router.options.routes,
      "name",
      "children"
    ).map;
    const shouldRemoveKeepAliveRouteNames = getRouteNamesFromTab(
      removeTabsConfig,
      routesMap
    );
    keepAliveRouteNames.value = keepAliveRouteNames.value.filter(
      (name) => !shouldRemoveKeepAliveRouteNames.some(
        (sholdRemoveName) => sholdRemoveName === name
      )
    );
  };
  return {
    defaultTabs,
    activeMenuIndex,
    activeTab,
    keepAliveRouteNames,
    clearRemoveTabsKeepAlive
  };
}
