var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var stdin_exports = {};
__export(stdin_exports, {
  removeTableHoverClass: () => removeTableHoverClass,
  useElTableSort: () => useElTableSort
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_sortablejs = __toESM(require("sortablejs"));
var import_pagoda_shared = require("pagoda-shared");
function removeTableHoverClass(elTableEl) {
  Array.from(elTableEl.querySelectorAll(".el-table__row")).forEach(
    (tr) => {
      (0, import_pagoda_shared.removeClass)(tr, "hover-row");
    }
  );
}
function useElTableSort({
  rowKey,
  cancelMove,
  onEnd
}) {
  const draging = (0, import_vue.ref)(false);
  const dragingItemKey = (0, import_vue.ref)(null);
  const dataIdAttr = "data-sortable-key";
  let sortable;
  const initTableSort = ({
    elTableEl,
    elTableData
  }) => {
    sortable == null ? void 0 : sortable.destroy();
    const tbody = elTableEl.querySelector(
      ".el-table__body-wrapper tbody"
    );
    const fixedTbody = elTableEl.querySelector(
      ".el-table__fixed tbody"
    );
    const fixedRightTbody = elTableEl.querySelector(
      ".el-table__fixed-right tbody"
    );
    const tableDataMap = (0, import_pagoda_shared.getMapFromTree)(elTableData, rowKey).map;
    const tbodyTrs = Array.from(tbody.querySelectorAll("tr"));
    const fixedTbodyTrs = fixedTbody ? Array.from(fixedTbody.querySelectorAll("tr")) : [];
    const fixedRightTbodyTrs = fixedRightTbody ? Array.from(fixedRightTbody.querySelectorAll("tr")) : [];
    tbodyTrs.forEach((tr, idx) => {
      const rowKeyValue = elTableData[idx][rowKey];
      tr.setAttribute(dataIdAttr, rowKeyValue);
      if (fixedTbody)
        fixedTbodyTrs[idx].setAttribute(dataIdAttr, rowKeyValue);
      if (fixedRightTbody)
        fixedRightTbodyTrs[idx].setAttribute(dataIdAttr, rowKeyValue);
    });
    const fixedSortable = fixedTbody && import_sortablejs.default.create(fixedTbody, {
      dataIdAttr,
      disabled: true
    });
    const fixedRightSortable = fixedRightTbody && import_sortablejs.default.create(fixedRightTbody, {
      dataIdAttr,
      disabled: true
    });
    sortable = import_sortablejs.default.create(tbody, {
      dataIdAttr,
      setData(dataTransfer) {
        dataTransfer.setData("Text", "");
      },
      onStart: ({ oldIndex }) => {
        draging.value = true;
        dragingItemKey.value = elTableData[oldIndex][rowKey];
        removeTableHoverClass(elTableEl);
      },
      onMove(event) {
        const relatedRowKey = event.related.getAttribute(dataIdAttr);
        const draggedRowKey = event.dragged.getAttribute(dataIdAttr);
        if (cancelMove == null ? void 0 : cancelMove(tableDataMap[draggedRowKey], tableDataMap[relatedRowKey]))
          return false;
      },
      onChange: () => {
        if (fixedSortable || fixedRightSortable) {
          const order = sortable.toArray();
          fixedSortable == null ? void 0 : fixedSortable.sort(order);
          fixedRightSortable == null ? void 0 : fixedRightSortable.sort(order);
        }
      },
      onEnd: (_0) => __async(this, [_0], function* ({ newIndex, oldIndex }) {
        const dragRow = elTableData[oldIndex];
        const relativeRow = elTableData[newIndex];
        elTableData.splice(oldIndex, 1);
        elTableData.splice(newIndex, 0, dragRow);
        draging.value = false;
        dragingItemKey.value = null;
        yield (0, import_vue.nextTick)();
        removeTableHoverClass(elTableEl);
        onEnd(dragRow, relativeRow);
      })
    });
  };
  const sortCellClasses = ({ row }) => {
    return draging.value ? dragingItemKey.value === row[rowKey] ? "sortable-draging-cell" : "sortable-cell" : "";
  };
  return {
    sortCellClasses,
    initTableSort
  };
}
