import type { TablePaginationProps } from './types';
import type { RenderTableColumnsProps } from './types';
import type { ExtractPropTypes } from 'vue';
import type { TableRequestHandler } from './composables/use-table-request';
import type { Sort } from 'element-plus/es/components/table/src/table/defaults';
export declare const tableProps: {
    wrapperHeight: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<(StringConstructor | NumberConstructor)[], unknown, unknown>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    request: {
        readonly type: import("vue").PropType<TableRequestHandler>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    onRequest: {
        readonly type: import("vue").PropType<(currentPage: number, pageSize: number, sortable?: Sort | null) => void>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    columns: {
        readonly type: import("vue").PropType<RenderTableColumnsProps[]>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    autoRequest: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, boolean, boolean>;
    pagination: import("element-plus/es/utils").EpPropFinalized<(new (...args: any[]) => TablePaginationProps) | (() => TablePaginationProps) | (((new (...args: any[]) => TablePaginationProps) | (() => TablePaginationProps)) | null)[], unknown, unknown, () => {}, boolean>;
    autoMinWidth: import("element-plus/es/utils").EpPropFinalized<BooleanConstructor, unknown, unknown, boolean, boolean>;
    data: never;
    size: {
        readonly type: import("vue").PropType<import("element-plus/es/utils").EpPropMergeType<StringConstructor, "" | "small" | "default" | "large", never>>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        __epPropKey: true;
    };
    width: (NumberConstructor | StringConstructor)[];
    height: (NumberConstructor | StringConstructor)[];
    maxHeight: (NumberConstructor | StringConstructor)[];
    fit: {
        type: BooleanConstructor;
        default: boolean;
    };
    stripe: BooleanConstructor;
    border: BooleanConstructor;
    rowKey: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["rowKey"]>;
    showHeader: {
        type: BooleanConstructor;
        default: boolean;
    };
    showSummary: BooleanConstructor;
    sumText: StringConstructor;
    summaryMethod: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["summaryMethod"]>;
    rowClassName: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["rowClassName"]>;
    rowStyle: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["rowStyle"]>;
    cellClassName: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["cellClassName"]>;
    cellStyle: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["cellStyle"]>;
    headerRowClassName: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["headerRowClassName"]>;
    headerRowStyle: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["headerRowStyle"]>;
    headerCellClassName: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["headerCellClassName"]>;
    headerCellStyle: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["headerCellStyle"]>;
    highlightCurrentRow: BooleanConstructor;
    currentRowKey: (NumberConstructor | StringConstructor)[];
    emptyText: StringConstructor;
    expandRowKeys: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["expandRowKeys"]>;
    defaultExpandAll: BooleanConstructor;
    defaultSort: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["defaultSort"]>;
    tooltipEffect: StringConstructor;
    tooltipOptions: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["tooltipOptions"]>;
    spanMethod: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["spanMethod"]>;
    selectOnIndeterminate: {
        type: BooleanConstructor;
        default: boolean;
    };
    indent: {
        type: NumberConstructor;
        default: number;
    };
    treeProps: {
        type: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["treeProps"]>;
        default: () => {
            hasChildren: string;
            children: string;
            checkStrictly: boolean;
        };
    };
    lazy: BooleanConstructor;
    load: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["load"]>;
    style: {
        type: import("vue").PropType<import("vue").CSSProperties>;
        default: () => {};
    };
    className: {
        type: StringConstructor;
        default: string;
    };
    tableLayout: {
        type: import("vue").PropType<"auto" | "fixed">;
        default: string;
    };
    scrollbarAlwaysOn: BooleanConstructor;
    flexible: BooleanConstructor;
    showOverflowTooltip: import("vue").PropType<import("element-plus/es/components/table/src/table/defaults").TableProps<import("element-plus/es/components/table/src/table/defaults").DefaultRow>["showOverflowTooltip"]>;
    appendFilterPanelTo: StringConstructor;
    scrollbarTabindex: {
        type: (NumberConstructor | StringConstructor)[];
        default: undefined;
    };
    allowDragLastColumn: {
        type: BooleanConstructor;
        default: boolean;
    };
};
export type TableProps = ExtractPropTypes<typeof tableProps>;
