/**
 * 自定义 PagodaUiError
 *
 * @constructor
 * @param scope - 异常简要信息，例如：Utils toString。
 * @param message - 异常详细信息。
 *
 */
export declare class PagodaUiError extends Error {
    constructor(scope: string, message: string);
}
/**
 * 控制台打印一个警告信息 PagodaUiError
 *
 * @param scope - 异常简要信息，例如：Utils toString
 * @param message - 异常详细信息。
 *
 */
export declare function throwWarn(scope: string, message: string): void;
/**
 * 判断一个异常是否是 PagodaUiError
 *
 * @param e - Error 对象
 *
 */
export declare function isPagodaUiError(e: Error): boolean;
