var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  useSelection: () => useSelection
});
module.exports = __toCommonJS(stdin_exports);
var import_vue = require("vue");
var import_utils = require("../utils");
var import_lodash_unified = require("lodash-unified");
function useSelection({
  tableData,
  selectable,
  onSelectionChange
}) {
  const selection = (0, import_vue.ref)([]);
  const isAllSelected = (0, import_vue.ref)(false);
  const getSelectionRows = () => {
    return (selection.value || []).slice();
  };
  const isSelected = (row) => {
    return selection.value.includes(row);
  };
  const toggleRowSelection = (row, selected) => {
    const changed = (0, import_utils.toggleRowStatus)(selection.value, row, selected);
    if (changed) {
      const newSelection = (selection.value || []).slice();
      onSelectionChange == null ? void 0 : onSelectionChange(newSelection);
    }
  };
  const updateAllSelected = () => {
    var _a;
    if (((_a = tableData.value) == null ? void 0 : _a.length) === 0) {
      isAllSelected.value = false;
      return;
    }
    const isSelected2 = function(row) {
      return selection.value.includes(row);
    };
    let isAllSelected_ = true;
    let selectedCount = 0;
    for (let i = 0, j = (tableData.value || []).length; i < j; i++) {
      const rowIndex = i;
      const item = tableData.value[i];
      const isRowSelectable = selectable.value && selectable.value.call(null, item, rowIndex);
      if (!isSelected2(item)) {
        if (!selectable.value || isRowSelectable) {
          isAllSelected_ = false;
          break;
        }
      } else {
        selectedCount++;
      }
    }
    if (selectedCount === 0)
      isAllSelected_ = false;
    isAllSelected.value = isAllSelected_;
  };
  const clearSelection = () => {
    isAllSelected.value = false;
    const oldSelection = selection.value;
    if (oldSelection.length) {
      selection.value = [];
      onSelectionChange == null ? void 0 : onSelectionChange([]);
    }
  };
  const toggleAllSelection = (0, import_lodash_unified.debounce)(() => {
    const value = !isAllSelected.value;
    isAllSelected.value = value;
    let selectionChanged = false;
    tableData.value.forEach((row, index) => {
      if (selectable.value) {
        if (selectable.value.call(null, row, index) && (0, import_utils.toggleRowStatus)(selection.value, row, value)) {
          selectionChanged = true;
        }
      } else {
        if ((0, import_utils.toggleRowStatus)(selection.value, row, value)) {
          selectionChanged = true;
        }
      }
    });
    if (selectionChanged) {
      onSelectionChange == null ? void 0 : onSelectionChange(selection.value ? selection.value.slice() : []);
    }
  }, 10);
  return {
    selection,
    isAllSelected,
    getSelectionRows,
    isSelected,
    toggleRowSelection,
    clearSelection,
    updateAllSelected,
    toggleAllSelection
  };
}
